/*
 * AdminContextBeanInfo.java
 *
 * BeanDoc generated on Fri Mar 16 at 12:39:54 EDT 02012.
 * 
 * See AdminContext.java for copyright information.
 */

package org.teatrove.teaservlet;

import java.beans.*;
import java.lang.reflect.*;

import java.util.Vector;

/**
 * The BeanInfo class describing AdminContext. 
 *
 * @author Brian S O'Neill
 */
public class AdminContextBeanInfo extends SimpleBeanInfo {

    /** BeanDescriptor returned by the <code>getBeanDescriptor</code> 
        method */
    private BeanDescriptor mBeanDescriptor;

    /** BeanInfo array returned by the <code>getAdditionalBeanInfo</code> 
        method */
    private BeanInfo[] mAdditionalBeanInfo;

    /** MethodDescriptor array returned by the 
        <code>getMethodDescriptors</code> method */
    private MethodDescriptor[] mMethodDescriptors;

    /** PropertyDescriptor array returned by the 
        <code>getPropertyDescriptors</code> method */
    private PropertyDescriptor[] mPropertyDescriptors;
    
    /** The index of the default property */
    private int mDefaultPropertyIndex;


    /**
     * Creates a new AdminContextBeanInfo.
     */
    public AdminContextBeanInfo() {        
                          
        mDefaultPropertyIndex = -1;
        
    }
     
    /**
     * Returns a BeanDescriptor that describes AdminContext.
     */    
    public BeanDescriptor getBeanDescriptor() {
        
        if (mBeanDescriptor == null) {
            mBeanDescriptor = createBeanDescriptor();       
        }

        return mBeanDescriptor;
    }

    /**
     * Returns a BeanInfo array containing BeanInfo object's for:<br>
     * <code>org.teatrove.teaservlet.TeaToolsContext</code><br>      
     */  
    public BeanInfo[] getAdditionalBeanInfo() {

        if (mAdditionalBeanInfo == null) {
            mAdditionalBeanInfo = createAdditionalBeanInfo();       
        }

        return mAdditionalBeanInfo;
    }

    /**    
     * Returns MethodDescriptors that describe the methods of 
     * AdminContext.  Call the 
     * <code>getAdditionalBeanInfo</code> method to get the 
     * method descriptors of the superclass and interfaces.
     */ 
    public MethodDescriptor[] getMethodDescriptors() {

        if (mMethodDescriptors == null) {
            mMethodDescriptors = createMethodDescriptors();       
        }

        return mMethodDescriptors;
    }

    /**    
     * Returns a PropertyDescriptor array that describes the properties of 
     * AdminContext.
     */ 
    public PropertyDescriptor[] getPropertyDescriptors() {

        if (mPropertyDescriptors == null) {
            mPropertyDescriptors = createPropertyDescriptors();     
        }

        return mPropertyDescriptors;
    }

    /**
     * Return the index of the default property.
     */
    public int getDefaultPropertyIndex() {
        return mDefaultPropertyIndex;
    }


    //
    // Non-public interface
    //

    // Create the bean descriptor for the bean.
    private BeanDescriptor createBeanDescriptor() {                        
        
        BeanDescriptor bd = 
            new BeanDescriptor(AdminContext.class);
        
        bd.setName("AdminContext");
        bd.setDisplayName("AdminContext");
        bd.setShortDescription("");        
        bd.setValue("BeanDoc", "4.1.2");
        
        return bd;
    }

    // Create the additional bean info objects for the bean.
    private BeanInfo[] createAdditionalBeanInfo() {
        
        Vector bis = new Vector();
        BeanInfo bi = null;                
        
        //
        // Get the BeanInfo for each interface
        //          
        
        bi = null;
        try {
            bi = Introspector.getBeanInfo(org.teatrove.teaservlet.TeaToolsContext.class);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }        
        
        if (bi != null) {    
            bis.addElement(bi);
        }            
                        
        BeanInfo[] additionalBeanInfo = null;
        if (bis.size() > 0) {
            additionalBeanInfo = new BeanInfo[bis.size()];
            bis.copyInto(additionalBeanInfo);
        }
        
        return additionalBeanInfo;
    }

    // Create the method descriptor objects for the bean.
    private MethodDescriptor[] createMethodDescriptors() {
                
        Class[] paramTypes = null;
        int paramIndex = 0;  
        ParameterDescriptor[] paramDescriptors = null;
        ParameterDescriptor pd = null;
        
        Vector mds = new Vector();
        Method m = null;
        MethodDescriptor md = null;

           
        
        //
        // addMilestone 
        //
        paramTypes = new Class[3];
        paramDescriptors = new ParameterDescriptor[3];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.teaservlet.stats.TemplateStats.class; 
        pd = new ParameterDescriptor();
        pd.setName("templateStats");
        pd.setDisplayName("org.teatrove.teaservlet.stats.TemplateStats"); 
        pd.setShortDescription("the template stats object to query."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("description");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("a description of the milestone"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("time");
        pd.setDisplayName("long"); 
        pd.setShortDescription("the time of the milestone"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("addMilestone", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("addMilestone");
            md.setDisplayName("addMilestone");
            md.setShortDescription("Adds a milestone for this template such as a compile event.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // addNote 
        //
        paramTypes = new Class[3];
        paramDescriptors = new ParameterDescriptor[3];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("ID");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("contents");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("lifespan");
        pd.setDisplayName("int"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("addNote", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("addNote");
            md.setDisplayName("addNote");
            md.setShortDescription("allows users to leave notes to each other from admin templates.\n when called with a null contents parameter, this will not update the \n messages but will still return the contents of the message list.  \n if the ID parameter is null, a list of all known IDs will be returned.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // checkTemplates 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = boolean.class; 
        pd = new ParameterDescriptor();
        pd.setName("all");
        pd.setDisplayName("boolean"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("checkTemplates", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("checkTemplates");
            md.setDisplayName("checkTemplates");  
            
            mds.addElement(md);
        }            
           
        
        //
        // checkTemplates 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String[].class; 
        pd = new ParameterDescriptor();
        pd.setName("templateNames");
        pd.setDisplayName("java.lang.String[]"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("checkTemplates", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("checkTemplates");
            md.setDisplayName("checkTemplates");  
            
            mds.addElement(md);
        }            
           
        
        //
        // dynamicTemplateCall 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("templateName");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("dynamicTemplateCall", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("dynamicTemplateCall");
            md.setDisplayName("dynamicTemplateCall");
            md.setShortDescription("allows a template to dynamically call another template");   
            
            mds.addElement(md);
        }            
           
        
        //
        // dynamicTemplateCall 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("templateName");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.Object[].class; 
        pd = new ParameterDescriptor();
        pd.setName("params");
        pd.setDisplayName("java.lang.Object[]"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("dynamicTemplateCall", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("dynamicTemplateCall");
            md.setDisplayName("dynamicTemplateCall");
            md.setShortDescription("allows a template to dynamically call another template\n this time with parameters.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // formatTypeDesc 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.trove.classfile.TypeDesc.class; 
        pd = new ParameterDescriptor();
        pd.setName("type");
        pd.setDisplayName("org.teatrove.trove.classfile.TypeDesc"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("formatTypeDesc", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("formatTypeDesc");
            md.setDisplayName("formatTypeDesc");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getAggregateIntervalForRawData 
        //
        paramTypes = new Class[3];
        paramDescriptors = new ParameterDescriptor[3];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.teaservlet.stats.TemplateStats.class; 
        pd = new ParameterDescriptor();
        pd.setName("templateStats");
        pd.setDisplayName("org.teatrove.teaservlet.stats.TemplateStats"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("startTime");
        pd.setDisplayName("long"); 
        pd.setShortDescription("the start time to filter on."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("stopTime");
        pd.setDisplayName("long"); 
        pd.setShortDescription("the stop time to filter on."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("getAggregateIntervalForRawData", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getAggregateIntervalForRawData");
            md.setDisplayName("getAggregateIntervalForRawData");
            md.setShortDescription("Returns an aggregate interval for the raw data filtered \n by start and stop time.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getAggregateIntervals 
        //
        paramTypes = new Class[3];
        paramDescriptors = new ParameterDescriptor[3];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.teaservlet.stats.TemplateStats.class; 
        pd = new ParameterDescriptor();
        pd.setName("templateStats");
        pd.setDisplayName("org.teatrove.teaservlet.stats.TemplateStats"); 
        pd.setShortDescription("the template stats object to query."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("startTime");
        pd.setDisplayName("long"); 
        pd.setShortDescription("the start time to filter on."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("stopTime");
        pd.setDisplayName("long"); 
        pd.setShortDescription("the stop time to filter on."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("getAggregateIntervals", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getAggregateIntervals");
            md.setDisplayName("getAggregateIntervals");
            md.setShortDescription("Returns the aggregate intervals for the specified startTime and stopTime.\n Any intervals that contain these two endpoints lie between them will be\n included.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getCallers 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("templateName");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("getCallers", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getCallers");
            md.setDisplayName("getCallers");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getClassForName 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("classname");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("getClassForName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getClassForName");
            md.setDisplayName("getClassForName");
            md.setShortDescription("Returns a Class object for a given name.\n it basically lets templates perform Class.forName(classname);");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getCompilationResults 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AdminContext.class.getMethod("getCompilationResults", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getCompilationResults");
            md.setDisplayName("getCompilationResults");
            md.setShortDescription("If the call to getTeaServletAdmin() caused a reload to occur,\n a call to this method will return the results of that reload.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getDurationAggregateSummary 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.teaservlet.stats.AggregateInterval[].class; 
        pd = new ParameterDescriptor();
        pd.setName("intervals");
        pd.setDisplayName("org.teatrove.teaservlet.stats.AggregateInterval[]"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("getDurationAggregateSummary", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getDurationAggregateSummary");
            md.setDisplayName("getDurationAggregateSummary");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getFunction 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("methodName");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("getFunction", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getFunction");
            md.setDisplayName("getFunction");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getMethodCallers 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.beans.MethodDescriptor.class; 
        pd = new ParameterDescriptor();
        pd.setName("methodDesc");
        pd.setDisplayName("java.beans.MethodDescriptor"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("getMethodCallers", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getMethodCallers");
            md.setDisplayName("getMethodCallers");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getMilestones 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.teaservlet.stats.TemplateStats.class; 
        pd = new ParameterDescriptor();
        pd.setName("templateStats");
        pd.setDisplayName("org.teatrove.teaservlet.stats.TemplateStats"); 
        pd.setShortDescription("the template stats object to query."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("getMilestones", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getMilestones");
            md.setDisplayName("getMilestones");
            md.setShortDescription("Returns all milestones for this template.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getMilestones 
        //
        paramTypes = new Class[3];
        paramDescriptors = new ParameterDescriptor[3];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.teaservlet.stats.TemplateStats.class; 
        pd = new ParameterDescriptor();
        pd.setName("templateStats");
        pd.setDisplayName("org.teatrove.teaservlet.stats.TemplateStats"); 
        pd.setShortDescription("the template stats object to query."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("startTime");
        pd.setDisplayName("long"); 
        pd.setShortDescription(""); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("stopTime");
        pd.setDisplayName("long"); 
        pd.setShortDescription(""); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("getMilestones", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getMilestones");
            md.setDisplayName("getMilestones");
            md.setShortDescription("Returns all milestones for this template between the start and stopTime.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getReloadStatusOfServers 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AdminContext.class.getMethod("getReloadStatusOfServers", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getReloadStatusOfServers");
            md.setDisplayName("getReloadStatusOfServers");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getStatistics 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("caller");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("callee");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("getStatistics", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getStatistics");
            md.setDisplayName("getStatistics");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getSubclassesForName 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("classname");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("getSubclassesForName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getSubclassesForName");
            md.setDisplayName("getSubclassesForName");
            md.setShortDescription("Returns a list of class objects for each known subclass.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getTeaServletAdmin 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AdminContext.class.getMethod("getTeaServletAdmin", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTeaServletAdmin");
            md.setDisplayName("getTeaServletAdmin");
            md.setShortDescription("Gets the admin information for the TeaServlet. The user also can\n reload the application or reload templates.\n <p>\n This function processes the following HTTP request parameters:\n <ul>\n <li>reloadTemplates - reloads the changed templates\n <li>reloadTemplates=all - reloads all templates\n <li>log - the id of the log\n <li>enabled - turns on/off the log (boolean)\n <li>debug - turns on/off log debug messages (boolean)\n <li>info - turns on/off log info messages (boolean)\n <li>warn - turns on/off log warning messages (boolean)\n <li>error - turns on/off log error messages (boolean)\n </ul>");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getTeaServletRequestStats 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AdminContext.class.getMethod("getTeaServletRequestStats", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTeaServletRequestStats");
            md.setDisplayName("getTeaServletRequestStats");
            md.setShortDescription("Returns object that manages template raw and aggregate statistics.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getTemplateInfo 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("templateName");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("getTemplateInfo", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTemplateInfo");
            md.setDisplayName("getTemplateInfo");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getTemplateInfos 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AdminContext.class.getMethod("getTemplateInfos", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTemplateInfos");
            md.setDisplayName("getTemplateInfos");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getTemplateStats 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AdminContext.class.getMethod("getTemplateStats", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTemplateStats");
            md.setDisplayName("getTemplateStats");
            md.setShortDescription("Returns an array of template stats.\n \n Returns the template raw and aggregate statistics so as to\n better understand the performance of templates through time.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getTemplateStats 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("fullTemplateName");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the name of the template with \'.\' as a seperator."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("getTemplateStats", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTemplateStats");
            md.setDisplayName("getTemplateStats");
            md.setShortDescription("Returns the template raw and aggregate statistics so as to\n better understand the performance of this template through time.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // isTemplateRepositoryEnabled 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AdminContext.class.getMethod("isTemplateRepositoryEnabled", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("isTemplateRepositoryEnabled");
            md.setDisplayName("isTemplateRepositoryEnabled");  
            
            mds.addElement(md);
        }            
           
        
        //
        // obtainContextByName 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("appName");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("obtainContextByName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("obtainContextByName");
            md.setDisplayName("obtainContextByName");
            md.setShortDescription("returns a context for the specified application instance by name.  \n this is useful when dynamically calling a function in that context.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // resetStatistics 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AdminContext.class.getMethod("resetStatistics", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("resetStatistics");
            md.setDisplayName("resetStatistics");  
            
            mds.addElement(md);
        }            
           
        
        //
        // resetStatistics 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("caller");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("callee");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("resetStatistics", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("resetStatistics");
            md.setDisplayName("resetStatistics");  
            
            mds.addElement(md);
        }            
           
        
        //
        // resetTemplateStats 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AdminContext.class.getMethod("resetTemplateStats", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("resetTemplateStats");
            md.setDisplayName("resetTemplateStats");
            md.setShortDescription("Resets the raw and aggregate template statistics.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // resetTemplateStats 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("templateName");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the name of the template to reset statistics for."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("resetTemplateStats", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("resetTemplateStats");
            md.setDisplayName("resetTemplateStats");
            md.setShortDescription("Resets the raw and aggregate template statistics. If null is passed in all templates\n statistics will be reset.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // search 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.teaservlet.stats.AggregateInterval[].class; 
        pd = new ParameterDescriptor();
        pd.setName("intervals");
        pd.setDisplayName("org.teatrove.teaservlet.stats.AggregateInterval[]"); 
        pd.setShortDescription("the aggregate intervals to search."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("time");
        pd.setDisplayName("long"); 
        pd.setShortDescription("aggregate intervals will be found for this time."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("search", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("search");
            md.setDisplayName("search");
            md.setShortDescription("This method returns the Aggregate interval containing the specified\n time stamp.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // search 
        //
        paramTypes = new Class[4];
        paramDescriptors = new ParameterDescriptor[4];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.teaservlet.stats.AggregateInterval[].class; 
        pd = new ParameterDescriptor();
        pd.setName("intervals");
        pd.setDisplayName("org.teatrove.teaservlet.stats.AggregateInterval[]"); 
        pd.setShortDescription("sorted array of AggregateIntervals"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("time");
        pd.setDisplayName("long"); 
        pd.setShortDescription("key to search for"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("begin");
        pd.setDisplayName("int"); 
        pd.setShortDescription("start position in the index"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("end");
        pd.setDisplayName("int"); 
        pd.setShortDescription("one past the end position in the index"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("search", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("search");
            md.setDisplayName("search");
            md.setShortDescription("Searches for a AggregateInterval which contains the time passed in.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // setAggregateWindowSize 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("aggregateWindowSize");
        pd.setDisplayName("int"); 
        pd.setShortDescription(""); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("setAggregateWindowSize", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("setAggregateWindowSize");
            md.setDisplayName("setAggregateWindowSize");
            md.setShortDescription("Sets the aggregate interval size. The aggregateWindowSize defines how many\n aggregate intervals are going to be kept in a circular queue.\n \n Resets all statistics.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // setRawWindowSize 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("rawWindowSize");
        pd.setDisplayName("int"); 
        pd.setShortDescription(""); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("setRawWindowSize", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("setRawWindowSize");
            md.setDisplayName("setRawWindowSize");
            md.setShortDescription("Sets the raw window size. The rawWindowSize defines how many\n raw statistics are going to be kept in a circular queue.\n \n Resets all statistics.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // setTemplateOrdering 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("orderBy");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("setTemplateOrdering", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("setTemplateOrdering");
            md.setDisplayName("setTemplateOrdering");  
            
            mds.addElement(md);
        }            
           
        
        //
        // streamClassBytes 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("className");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = AdminContext.class.getMethod("streamClassBytes", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("streamClassBytes");
            md.setDisplayName("streamClassBytes");
            md.setShortDescription("Streams the structural bytes of the named class via the HttpResponse.");   
            
            mds.addElement(md);
        }            
               
                         
        MethodDescriptor[] methodDescriptors = 
                                new MethodDescriptor[mds.size()];
        mds.copyInto(methodDescriptors);
                
        return methodDescriptors;
    }

    // Create the property descriptor objects for the bean.
    private PropertyDescriptor[] createPropertyDescriptors() {
                           
        PropertyDescriptor[] propertyDescriptors = new PropertyDescriptor[10];
        PropertyDescriptor pd = null;
        int propertyIndex = 0;          
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("compilationResults", AdminContext.class, "getCompilationResults", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("compilationResults");
            pd.setShortDescription("If the call to getTeaServletAdmin() caused a reload to occur,\n a call to this method will return the results of that reload.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("reloadStatusOfServers", AdminContext.class, "getReloadStatusOfServers", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("reloadStatusOfServers");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("teaServletAdmin", AdminContext.class, "getTeaServletAdmin", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("teaServletAdmin");
            pd.setShortDescription("The admin information for the TeaServlet. The user also can\n reload the application or reload templates.\n <p>\n This function processes the following HTTP request parameters:\n <ul>\n <li>reloadTemplates - reloads the changed templates\n <li>reloadTemplates=all - reloads all templates\n <li>log - the id of the log\n <li>enabled - turns on/off the log (boolean)\n <li>debug - turns on/off log debug messages (boolean)\n <li>info - turns on/off log info messages (boolean)\n <li>warn - turns on/off log warning messages (boolean)\n <li>error - turns on/off log error messages (boolean)\n </ul>");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("teaServletRequestStats", AdminContext.class, "getTeaServletRequestStats", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("teaServletRequestStats");
            pd.setShortDescription("Object that manages template raw and aggregate statistics.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("templateInfos", AdminContext.class, "getTemplateInfos", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("templateInfos");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("templateStats", AdminContext.class, "getTemplateStats", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("templateStats");
            pd.setShortDescription("An array of template stats.\n \n Returns the template raw and aggregate statistics so as to\n better understand the performance of templates through time.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("templateRepositoryEnabled", AdminContext.class, "isTemplateRepositoryEnabled", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("templateRepositoryEnabled");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("aggregateWindowSize", AdminContext.class, null, "setAggregateWindowSize");
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("aggregateWindowSize");
            pd.setShortDescription("The aggregate interval size. The aggregateWindowSize defines how many\n aggregate intervals are going to be kept in a circular queue.\n \n Resets all statistics.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("rawWindowSize", AdminContext.class, null, "setRawWindowSize");
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("rawWindowSize");
            pd.setShortDescription("The raw window size. The rawWindowSize defines how many\n raw statistics are going to be kept in a circular queue.\n \n Resets all statistics.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("templateOrdering", AdminContext.class, null, "setTemplateOrdering");
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("templateOrdering");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
        
        if (propertyDescriptors.length == 0) {
            propertyDescriptors = null;    
        }
        
        return propertyDescriptors;
    }

}