/*
 * ApplicationBeanInfo.java
 *
 * BeanDoc generated on Fri Mar 16 at 12:39:54 EDT 02012.
 * 
 * See Application.java for copyright information.
 */

package org.teatrove.teaservlet;

import java.beans.*;
import java.lang.reflect.*;

import java.util.Vector;

/**
 * The BeanInfo class describing Application. 
 *
 * @author Reece Wilton
 */
public class ApplicationBeanInfo extends SimpleBeanInfo {

    /** BeanDescriptor returned by the <code>getBeanDescriptor</code> 
        method */
    private BeanDescriptor mBeanDescriptor;

    /** BeanInfo array returned by the <code>getAdditionalBeanInfo</code> 
        method */
    private BeanInfo[] mAdditionalBeanInfo;

    /** MethodDescriptor array returned by the 
        <code>getMethodDescriptors</code> method */
    private MethodDescriptor[] mMethodDescriptors;

    /** PropertyDescriptor array returned by the 
        <code>getPropertyDescriptors</code> method */
    private PropertyDescriptor[] mPropertyDescriptors;
    
    /** The index of the default property */
    private int mDefaultPropertyIndex;


    /**
     * Creates a new ApplicationBeanInfo.
     */
    public ApplicationBeanInfo() {        
                          
        mDefaultPropertyIndex = -1;
        
    }
     
    /**
     * Returns a BeanDescriptor that describes Application.
     */    
    public BeanDescriptor getBeanDescriptor() {
        
        if (mBeanDescriptor == null) {
            mBeanDescriptor = createBeanDescriptor();       
        }

        return mBeanDescriptor;
    }

    /**
     * Returns a BeanInfo array containing BeanInfo object's for:<br>      
     */  
    public BeanInfo[] getAdditionalBeanInfo() {

        if (mAdditionalBeanInfo == null) {
            mAdditionalBeanInfo = createAdditionalBeanInfo();       
        }

        return mAdditionalBeanInfo;
    }

    /**    
     * Returns MethodDescriptors that describe the methods of 
     * Application.  Call the 
     * <code>getAdditionalBeanInfo</code> method to get the 
     * method descriptors of the superclass and interfaces.
     */ 
    public MethodDescriptor[] getMethodDescriptors() {

        if (mMethodDescriptors == null) {
            mMethodDescriptors = createMethodDescriptors();       
        }

        return mMethodDescriptors;
    }

    /**    
     * Returns a PropertyDescriptor array that describes the properties of 
     * Application.
     */ 
    public PropertyDescriptor[] getPropertyDescriptors() {

        if (mPropertyDescriptors == null) {
            mPropertyDescriptors = createPropertyDescriptors();     
        }

        return mPropertyDescriptors;
    }

    /**
     * Return the index of the default property.
     */
    public int getDefaultPropertyIndex() {
        return mDefaultPropertyIndex;
    }


    //
    // Non-public interface
    //

    // Create the bean descriptor for the bean.
    private BeanDescriptor createBeanDescriptor() {                        
        
        BeanDescriptor bd = 
            new BeanDescriptor(Application.class);
        
        bd.setName("Application");
        bd.setDisplayName("Application");
        bd.setShortDescription("The main hook into the TeaServlet framework. Implement this interface for\n instantiating other required components and for providing functions to\n templates.");        
        bd.setValue("BeanDoc", "4.1.2");
        
        return bd;
    }

    // Create the additional bean info objects for the bean.
    private BeanInfo[] createAdditionalBeanInfo() {
        
        Vector bis = new Vector();
        BeanInfo bi = null;                
                        
        BeanInfo[] additionalBeanInfo = null;
        if (bis.size() > 0) {
            additionalBeanInfo = new BeanInfo[bis.size()];
            bis.copyInto(additionalBeanInfo);
        }
        
        return additionalBeanInfo;
    }

    // Create the method descriptor objects for the bean.
    private MethodDescriptor[] createMethodDescriptors() {
                
        Class[] paramTypes = null;
        int paramIndex = 0;  
        ParameterDescriptor[] paramDescriptors = null;
        ParameterDescriptor pd = null;
        
        Vector mds = new Vector();
        Method m = null;
        MethodDescriptor md = null;

           
        
        //
        // createContext 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.teaservlet.ApplicationRequest.class; 
        pd = new ParameterDescriptor();
        pd.setName("request");
        pd.setDisplayName("org.teatrove.teaservlet.ApplicationRequest"); 
        pd.setShortDescription("the client\'s HTTP request"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = org.teatrove.teaservlet.ApplicationResponse.class; 
        pd = new ParameterDescriptor();
        pd.setName("response");
        pd.setDisplayName("org.teatrove.teaservlet.ApplicationResponse"); 
        pd.setShortDescription("the client\'s HTTP response"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = Application.class.getMethod("createContext", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("createContext");
            md.setDisplayName("createContext");
            md.setShortDescription("Creates a context, which defines functions that are callable by\n templates. Any public method in the context is a callable function,\n except methods defined in Object. A context may receive a request and\n response, but it doesn\'t need to use any of them. They are provided only\n in the event that a function needs access to these objects.\n <p>\n Unless the getContextType method returns null, the createContext method\n is called once for every request to the TeaServlet, so context creation\n should have a fairly quick initialization. One way of accomplishing this\n is to return the same context instance each time. The drawback to this\n technique is that functions will not be able to access the current\n request and response.\n <p>\n The recommended technique is to construct a new context that simply\n references this Application and any of the passed in parameters. This\n way, the Application contains all the resources and \"business logic\",\n and the context just provides templates access to it.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // destroy 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = Application.class.getMethod("destroy", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("destroy");
            md.setDisplayName("destroy");
            md.setShortDescription("Called by the TeaServlet when the application is no longer needed.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getContextType 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = Application.class.getMethod("getContextType", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getContextType");
            md.setDisplayName("getContextType");
            md.setShortDescription("The class of the object that the createContext method will return, which\n does not need to implement any special interface or extend any special\n class. Returning null indicates that this Application defines no\n context, and createContext will never be called.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // init 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.teaservlet.ApplicationConfig.class; 
        pd = new ParameterDescriptor();
        pd.setName("config");
        pd.setDisplayName("org.teatrove.teaservlet.ApplicationConfig"); 
        pd.setShortDescription("the application\'s configuration object"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = Application.class.getMethod("init", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("init");
            md.setDisplayName("init");
            md.setShortDescription("Initializes resources used by the Application.");   
            
            mds.addElement(md);
        }            
               
                         
        MethodDescriptor[] methodDescriptors = 
                                new MethodDescriptor[mds.size()];
        mds.copyInto(methodDescriptors);
                
        return methodDescriptors;
    }

    // Create the property descriptor objects for the bean.
    private PropertyDescriptor[] createPropertyDescriptors() {
                           
        PropertyDescriptor[] propertyDescriptors = new PropertyDescriptor[1];
        PropertyDescriptor pd = null;
        int propertyIndex = 0;          
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("contextType", Application.class, "getContextType", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("contextType");
            pd.setShortDescription("The class of the object that the createContext method will return, which\n does not need to implement any special interface or extend any special\n class. Returning null indicates that this Application defines no\n context, and createContext will never be called.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
        
        if (propertyDescriptors.length == 0) {
            propertyDescriptors = null;    
        }
        
        return propertyDescriptors;
    }

}