/*
 * ApplicationDepotBeanInfo.java
 *
 * BeanDoc generated on Fri Mar 16 at 12:39:54 EDT 02012.
 * 
 * See ApplicationDepot.java for copyright information.
 */

package org.teatrove.teaservlet;

import java.beans.*;
import java.lang.reflect.*;

import java.util.Vector;

/**
 * The BeanInfo class describing ApplicationDepot. 
 *
 * @author Reece Wilton, Jonathan Colwell
 */
public class ApplicationDepotBeanInfo extends SimpleBeanInfo {

    /** BeanDescriptor returned by the <code>getBeanDescriptor</code> 
        method */
    private BeanDescriptor mBeanDescriptor;

    /** BeanInfo array returned by the <code>getAdditionalBeanInfo</code> 
        method */
    private BeanInfo[] mAdditionalBeanInfo;

    /** MethodDescriptor array returned by the 
        <code>getMethodDescriptors</code> method */
    private MethodDescriptor[] mMethodDescriptors;

    /** PropertyDescriptor array returned by the 
        <code>getPropertyDescriptors</code> method */
    private PropertyDescriptor[] mPropertyDescriptors;
    
    /** The index of the default property */
    private int mDefaultPropertyIndex;


    /**
     * Creates a new ApplicationDepotBeanInfo.
     */
    public ApplicationDepotBeanInfo() {        
                          
        mDefaultPropertyIndex = -1;
        
    }
     
    /**
     * Returns a BeanDescriptor that describes ApplicationDepot.
     */    
    public BeanDescriptor getBeanDescriptor() {
        
        if (mBeanDescriptor == null) {
            mBeanDescriptor = createBeanDescriptor();       
        }

        return mBeanDescriptor;
    }

    /**
     * Returns a BeanInfo array containing BeanInfo object's for:<br>
     * <code>java.lang.Object</code><br>      
     */  
    public BeanInfo[] getAdditionalBeanInfo() {

        if (mAdditionalBeanInfo == null) {
            mAdditionalBeanInfo = createAdditionalBeanInfo();       
        }

        return mAdditionalBeanInfo;
    }

    /**    
     * Returns MethodDescriptors that describe the methods of 
     * ApplicationDepot.  Call the 
     * <code>getAdditionalBeanInfo</code> method to get the 
     * method descriptors of the superclass and interfaces.
     */ 
    public MethodDescriptor[] getMethodDescriptors() {

        if (mMethodDescriptors == null) {
            mMethodDescriptors = createMethodDescriptors();       
        }

        return mMethodDescriptors;
    }

    /**    
     * Returns a PropertyDescriptor array that describes the properties of 
     * ApplicationDepot.
     */ 
    public PropertyDescriptor[] getPropertyDescriptors() {

        if (mPropertyDescriptors == null) {
            mPropertyDescriptors = createPropertyDescriptors();     
        }

        return mPropertyDescriptors;
    }

    /**
     * Return the index of the default property.
     */
    public int getDefaultPropertyIndex() {
        return mDefaultPropertyIndex;
    }


    //
    // Non-public interface
    //

    // Create the bean descriptor for the bean.
    private BeanDescriptor createBeanDescriptor() {                        
        
        BeanDescriptor bd = 
            new BeanDescriptor(ApplicationDepot.class);
        
        bd.setName("ApplicationDepot");
        bd.setDisplayName("ApplicationDepot");
        bd.setShortDescription("The ApplicationDepot stores the Applications that were specified in the\n props file. The ApplicationDepot is also responsible for creating logs for\n each Application.\n <p>\n depot -- a place for storing goods");        
        bd.setValue("BeanDoc", "4.1.2");
        
        return bd;
    }

    // Create the additional bean info objects for the bean.
    private BeanInfo[] createAdditionalBeanInfo() {
        
        Vector bis = new Vector();
        BeanInfo bi = null;                
        
        bi = null;
        try {
            // Get the BeanInfo for the superclass
            bi = Introspector.getBeanInfo(java.lang.Object.class);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }        
        
        if (bi != null) {    
            bis.addElement(bi);
        }                            
                        
        BeanInfo[] additionalBeanInfo = null;
        if (bis.size() > 0) {
            additionalBeanInfo = new BeanInfo[bis.size()];
            bis.copyInto(additionalBeanInfo);
        }
        
        return additionalBeanInfo;
    }

    // Create the method descriptor objects for the bean.
    private MethodDescriptor[] createMethodDescriptors() {
                
        Class[] paramTypes = null;
        int paramIndex = 0;  
        ParameterDescriptor[] paramDescriptors = null;
        ParameterDescriptor pd = null;
        
        Vector mds = new Vector();
        Method m = null;
        MethodDescriptor md = null;

           
        
        //
        // cleanName 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("name");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = ApplicationDepot.class.getMethod("cleanName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("cleanName");
            md.setDisplayName("cleanName");
            md.setShortDescription("Ensures that name only contains valid Java identifiers by converting\n non identifier characters to \'$\' characters. If name begins with a\n numeral, name is prefixed with an underscore. The returned name is also\n trimmed at the first hyphen character, if there is one. This allows\n multiple applications to appear to provide a unified set of functions.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // destroy 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = ApplicationDepot.class.getMethod("destroy", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("destroy");
            md.setDisplayName("destroy");
            md.setShortDescription("This method destroys the ApplicationDepot.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getApplicationForClassName 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("className");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = ApplicationDepot.class.getMethod("getApplicationForClassName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getApplicationForClassName");
            md.setDisplayName("getApplicationForClassName");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getApplicationNames 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = ApplicationDepot.class.getMethod("getApplicationNames", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getApplicationNames");
            md.setDisplayName("getApplicationNames");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getApplications 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = ApplicationDepot.class.getMethod("getApplications", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getApplications");
            md.setDisplayName("getApplications");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getContextPrefixNames 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = ApplicationDepot.class.getMethod("getContextPrefixNames", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getContextPrefixNames");
            md.setDisplayName("getContextPrefixNames");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getContextSource 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = ApplicationDepot.class.getMethod("getContextSource", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getContextSource");
            md.setDisplayName("getContextSource");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getContextType 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = ApplicationDepot.class.getMethod("getContextType", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getContextType");
            md.setDisplayName("getContextType");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getGenericContextSource 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = ApplicationDepot.class.getMethod("getGenericContextSource", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getGenericContextSource");
            md.setDisplayName("getGenericContextSource");  
            
            mds.addElement(md);
        }            
           
        
        //
        // reloadContextSource 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = ApplicationDepot.class.getMethod("reloadContextSource", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("reloadContextSource");
            md.setDisplayName("reloadContextSource");  
            
            mds.addElement(md);
        }            
           
        
        //
        // reloadGenericContextSource 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = ApplicationDepot.class.getMethod("reloadGenericContextSource", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("reloadGenericContextSource");
            md.setDisplayName("reloadGenericContextSource");  
            
            mds.addElement(md);
        }            
           
        
        //
        // setContextSource 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.tea.engine.ContextSource.class; 
        pd = new ParameterDescriptor();
        pd.setName("contextSource");
        pd.setDisplayName("org.teatrove.tea.engine.ContextSource"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = ApplicationDepot.class.getMethod("setContextSource", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("setContextSource");
            md.setDisplayName("setContextSource");  
            
            mds.addElement(md);
        }            
               
                         
        MethodDescriptor[] methodDescriptors = 
                                new MethodDescriptor[mds.size()];
        mds.copyInto(methodDescriptors);
                
        return methodDescriptors;
    }

    // Create the property descriptor objects for the bean.
    private PropertyDescriptor[] createPropertyDescriptors() {
                           
        PropertyDescriptor[] propertyDescriptors = new PropertyDescriptor[6];
        PropertyDescriptor pd = null;
        int propertyIndex = 0;          
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("applicationNames", ApplicationDepot.class, "getApplicationNames", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("applicationNames");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("applications", ApplicationDepot.class, "getApplications", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("applications");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("contextPrefixNames", ApplicationDepot.class, "getContextPrefixNames", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("contextPrefixNames");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("contextSource", ApplicationDepot.class, "getContextSource", "setContextSource");
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("contextSource");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("contextType", ApplicationDepot.class, "getContextType", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("contextType");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("genericContextSource", ApplicationDepot.class, "getGenericContextSource", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("genericContextSource");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
        
        if (propertyDescriptors.length == 0) {
            propertyDescriptors = null;    
        }
        
        return propertyDescriptors;
    }

}