/*
 * ApplicationResponseBeanInfo.java
 *
 * BeanDoc generated on Fri Mar 16 at 12:39:54 EDT 02012.
 * 
 * See ApplicationResponse.java for copyright information.
 */

package org.teatrove.teaservlet;

import java.beans.*;
import java.lang.reflect.*;

import java.util.Vector;

/**
 * The BeanInfo class describing ApplicationResponse. 
 *
 * @author Brian S O'Neill
 */
public class ApplicationResponseBeanInfo extends SimpleBeanInfo {

    /** BeanDescriptor returned by the <code>getBeanDescriptor</code> 
        method */
    private BeanDescriptor mBeanDescriptor;

    /** BeanInfo array returned by the <code>getAdditionalBeanInfo</code> 
        method */
    private BeanInfo[] mAdditionalBeanInfo;

    /** MethodDescriptor array returned by the 
        <code>getMethodDescriptors</code> method */
    private MethodDescriptor[] mMethodDescriptors;

    /** PropertyDescriptor array returned by the 
        <code>getPropertyDescriptors</code> method */
    private PropertyDescriptor[] mPropertyDescriptors;
    
    /** The index of the default property */
    private int mDefaultPropertyIndex;


    /**
     * Creates a new ApplicationResponseBeanInfo.
     */
    public ApplicationResponseBeanInfo() {        
                          
        mDefaultPropertyIndex = -1;
        
    }
     
    /**
     * Returns a BeanDescriptor that describes ApplicationResponse.
     */    
    public BeanDescriptor getBeanDescriptor() {
        
        if (mBeanDescriptor == null) {
            mBeanDescriptor = createBeanDescriptor();       
        }

        return mBeanDescriptor;
    }

    /**
     * Returns a BeanInfo array containing BeanInfo object's for:<br>
     * <code>javax.servlet.http.HttpServletResponse</code><br>      
     */  
    public BeanInfo[] getAdditionalBeanInfo() {

        if (mAdditionalBeanInfo == null) {
            mAdditionalBeanInfo = createAdditionalBeanInfo();       
        }

        return mAdditionalBeanInfo;
    }

    /**    
     * Returns MethodDescriptors that describe the methods of 
     * ApplicationResponse.  Call the 
     * <code>getAdditionalBeanInfo</code> method to get the 
     * method descriptors of the superclass and interfaces.
     */ 
    public MethodDescriptor[] getMethodDescriptors() {

        if (mMethodDescriptors == null) {
            mMethodDescriptors = createMethodDescriptors();       
        }

        return mMethodDescriptors;
    }

    /**    
     * Returns a PropertyDescriptor array that describes the properties of 
     * ApplicationResponse.
     */ 
    public PropertyDescriptor[] getPropertyDescriptors() {

        if (mPropertyDescriptors == null) {
            mPropertyDescriptors = createPropertyDescriptors();     
        }

        return mPropertyDescriptors;
    }

    /**
     * Return the index of the default property.
     */
    public int getDefaultPropertyIndex() {
        return mDefaultPropertyIndex;
    }


    //
    // Non-public interface
    //

    // Create the bean descriptor for the bean.
    private BeanDescriptor createBeanDescriptor() {                        
        
        BeanDescriptor bd = 
            new BeanDescriptor(ApplicationResponse.class);
        
        bd.setName("ApplicationResponse");
        bd.setDisplayName("ApplicationResponse");
        bd.setShortDescription("An ordinary HttpServletResponse, but with additional operations specific\n to the TeaServlet.");        
        bd.setValue("BeanDoc", "4.1.2");
        
        return bd;
    }

    // Create the additional bean info objects for the bean.
    private BeanInfo[] createAdditionalBeanInfo() {
        
        Vector bis = new Vector();
        BeanInfo bi = null;                
        
        //
        // Get the BeanInfo for each interface
        //          
        
        bi = null;
        try {
            bi = Introspector.getBeanInfo(javax.servlet.http.HttpServletResponse.class);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }        
        
        if (bi != null) {    
            bis.addElement(bi);
        }            
                        
        BeanInfo[] additionalBeanInfo = null;
        if (bis.size() > 0) {
            additionalBeanInfo = new BeanInfo[bis.size()];
            bis.copyInto(additionalBeanInfo);
        }
        
        return additionalBeanInfo;
    }

    // Create the method descriptor objects for the bean.
    private MethodDescriptor[] createMethodDescriptors() {
                
        Class[] paramTypes = null;
        int paramIndex = 0;  
        ParameterDescriptor[] paramDescriptors = null;
        ParameterDescriptor pd = null;
        
        Vector mds = new Vector();
        Method m = null;
        MethodDescriptor md = null;

           
        
        //
        // execDetached 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.teaservlet.ApplicationResponse.Command.class; 
        pd = new ParameterDescriptor();
        pd.setName("command");
        pd.setDisplayName("org.teatrove.teaservlet.ApplicationResponse.Command"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = ApplicationResponse.class.getMethod("execDetached", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("execDetached");
            md.setDisplayName("execDetached");
            md.setShortDescription("Execute the given command and detach everything sent to the\n ApplicationResponse in a way that\'s safe to do asynchronously.\n This is useful for certain caching strategies. The ApplicationResponse\n given to the command contains a new context instance and output buffer.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // execDetached 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.tea.runtime.Substitution.class; 
        pd = new ParameterDescriptor();
        pd.setName("s");
        pd.setDisplayName("org.teatrove.tea.runtime.Substitution"); 
        pd.setShortDescription("template substitution block that will be executed"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = ApplicationResponse.class.getMethod("execDetached", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("execDetached");
            md.setDisplayName("execDetached");
            md.setShortDescription("Execute the given template substitution and detach everything sent to\n the ApplicationResponse in a way that\'s safe to do asynchronously.\n This is useful for certain caching strategies. The substitution is\n detached and executed with a new context instance and output buffer.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // finish 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = ApplicationResponse.class.getMethod("finish", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("finish");
            md.setDisplayName("finish");
            md.setShortDescription("Commits this response and fully writes out the buffered contents unless\n there was a redirect or an error. Subsequent calls to finish have no\n affect.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getHttpContext 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = ApplicationResponse.class.getMethod("getHttpContext", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getHttpContext");
            md.setDisplayName("getHttpContext");
            md.setShortDescription("Provides direct access to the HttpContext that the template has access\n to. This allows functions to directly control locale and formatting\n settings as well as perform string conversion against the current\n format settings.\n <p>\n The returned HttpContext instance is actually an auto-generated class\n that merges all the application contexts into one. Application context\n instances are requested only when the merged context first needs to\n invoke a function from that context.\n <p>\n Application functions can access functions provided by other\n applications, possibly using the Java reflection APIs. Also, the merged\n class implements as many context interfaces as possible. Therefore,\n casting the context to an expected type can also be used to access other\n application functions.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getResponseBuffer 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = ApplicationResponse.class.getMethod("getResponseBuffer", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getResponseBuffer");
            md.setDisplayName("getResponseBuffer");
            md.setShortDescription("Returns the internal buffer that stores the response. Applications can\n use this to directly supply character or byte data to be output.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // insertCommand 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.teaservlet.ApplicationResponse.Command.class; 
        pd = new ParameterDescriptor();
        pd.setName("command");
        pd.setDisplayName("org.teatrove.teaservlet.ApplicationResponse.Command"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = ApplicationResponse.class.getMethod("insertCommand", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("insertCommand");
            md.setDisplayName("insertCommand");
            md.setShortDescription("Insert an arbitrary command into this response. If this response is\n saving its state in a DetachedData instance, then the command\n will be executed every time the DetachedData is played back.\n If this response isn\'t detached, the command is not executed and false\n is returned.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // isRedirectOrError 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = ApplicationResponse.class.getMethod("isRedirectOrError", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("isRedirectOrError");
            md.setDisplayName("isRedirectOrError");
            md.setShortDescription("Returns whether a redirect or error will be sent to the client. This\n is set to true when sendError or sendRedirect is called on the response.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // stealOutput 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.tea.runtime.Substitution.class; 
        pd = new ParameterDescriptor();
        pd.setName("s");
        pd.setDisplayName("org.teatrove.tea.runtime.Substitution"); 
        pd.setShortDescription("template substitution block that will be executed"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = org.teatrove.tea.runtime.OutputReceiver.class; 
        pd = new ParameterDescriptor();
        pd.setName("receiver");
        pd.setDisplayName("org.teatrove.tea.runtime.OutputReceiver"); 
        pd.setShortDescription("receives all the output generated by the substitution"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = ApplicationResponse.class.getMethod("stealOutput", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("stealOutput");
            md.setDisplayName("stealOutput");
            md.setShortDescription("Execute the given template substitution, but steal any output that would\n have gone directly to the response buffer. Applications can use this\n to specially handle the output of special objects. For example, an\n application can supply functions that allow templates to create\n downloadable images. By stealing the output, printed text can go to the\n image instead of corrupting the encoding.\n <p>\n Note: stealOutput is designed to run in the same thread that executed\n the main template. If the substitution needs to run in a separate\n thread, consider {@link #execDetached} instead.");   
            
            mds.addElement(md);
        }            
               
                         
        MethodDescriptor[] methodDescriptors = 
                                new MethodDescriptor[mds.size()];
        mds.copyInto(methodDescriptors);
                
        return methodDescriptors;
    }

    // Create the property descriptor objects for the bean.
    private PropertyDescriptor[] createPropertyDescriptors() {
                           
        PropertyDescriptor[] propertyDescriptors = new PropertyDescriptor[3];
        PropertyDescriptor pd = null;
        int propertyIndex = 0;          
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("httpContext", ApplicationResponse.class, "getHttpContext", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("httpContext");
            pd.setShortDescription("Provides direct access to the HttpContext that the template has access\n to. This allows functions to directly control locale and formatting\n settings as well as perform string conversion against the current\n format settings.\n <p>\n The returned HttpContext instance is actually an auto-generated class\n that merges all the application contexts into one. Application context\n instances are requested only when the merged context first needs to\n invoke a function from that context.\n <p>\n Application functions can access functions provided by other\n applications, possibly using the Java reflection APIs. Also, the merged\n class implements as many context interfaces as possible. Therefore,\n casting the context to an expected type can also be used to access other\n application functions.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("responseBuffer", ApplicationResponse.class, "getResponseBuffer", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("responseBuffer");
            pd.setShortDescription("The internal buffer that stores the response. Applications can\n use this to directly supply character or byte data to be output.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("redirectOrError", ApplicationResponse.class, "isRedirectOrError", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("redirectOrError");
            pd.setShortDescription("Whether a redirect or error will be sent to the client. This\n is set to true when sendError or sendRedirect is called on the response.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
        
        if (propertyDescriptors.length == 0) {
            propertyDescriptors = null;    
        }
        
        return propertyDescriptors;
    }

}