/*
 * HttpContextBeanInfo.java
 *
 * BeanDoc generated on Fri Mar 16 at 12:39:54 EDT 02012.
 * 
 * See HttpContext.java for copyright information.
 */

package org.teatrove.teaservlet;

import java.beans.*;
import java.lang.reflect.*;

import java.util.Vector;

/**
 * The BeanInfo class describing HttpContext. 
 *
 * @author Reece Wilton, Brian S O'Neill
 */
public class HttpContextBeanInfo extends SimpleBeanInfo {

    /** BeanDescriptor returned by the <code>getBeanDescriptor</code> 
        method */
    private BeanDescriptor mBeanDescriptor;

    /** BeanInfo array returned by the <code>getAdditionalBeanInfo</code> 
        method */
    private BeanInfo[] mAdditionalBeanInfo;

    /** MethodDescriptor array returned by the 
        <code>getMethodDescriptors</code> method */
    private MethodDescriptor[] mMethodDescriptors;

    /** PropertyDescriptor array returned by the 
        <code>getPropertyDescriptors</code> method */
    private PropertyDescriptor[] mPropertyDescriptors;
    
    /** The index of the default property */
    private int mDefaultPropertyIndex;


    /**
     * Creates a new HttpContextBeanInfo.
     */
    public HttpContextBeanInfo() {        
                          
        mDefaultPropertyIndex = -1;
        
    }
     
    /**
     * Returns a BeanDescriptor that describes HttpContext.
     */    
    public BeanDescriptor getBeanDescriptor() {
        
        if (mBeanDescriptor == null) {
            mBeanDescriptor = createBeanDescriptor();       
        }

        return mBeanDescriptor;
    }

    /**
     * Returns a BeanInfo array containing BeanInfo object's for:<br>
     * <code>org.teatrove.tea.runtime.UtilityContext</code><br>      
     */  
    public BeanInfo[] getAdditionalBeanInfo() {

        if (mAdditionalBeanInfo == null) {
            mAdditionalBeanInfo = createAdditionalBeanInfo();       
        }

        return mAdditionalBeanInfo;
    }

    /**    
     * Returns MethodDescriptors that describe the methods of 
     * HttpContext.  Call the 
     * <code>getAdditionalBeanInfo</code> method to get the 
     * method descriptors of the superclass and interfaces.
     */ 
    public MethodDescriptor[] getMethodDescriptors() {

        if (mMethodDescriptors == null) {
            mMethodDescriptors = createMethodDescriptors();       
        }

        return mMethodDescriptors;
    }

    /**    
     * Returns a PropertyDescriptor array that describes the properties of 
     * HttpContext.
     */ 
    public PropertyDescriptor[] getPropertyDescriptors() {

        if (mPropertyDescriptors == null) {
            mPropertyDescriptors = createPropertyDescriptors();     
        }

        return mPropertyDescriptors;
    }

    /**
     * Return the index of the default property.
     */
    public int getDefaultPropertyIndex() {
        return mDefaultPropertyIndex;
    }


    //
    // Non-public interface
    //

    // Create the bean descriptor for the bean.
    private BeanDescriptor createBeanDescriptor() {                        
        
        BeanDescriptor bd = 
            new BeanDescriptor(HttpContext.class);
        
        bd.setName("HttpContext");
        bd.setDisplayName("HttpContext");
        bd.setShortDescription("The context that is used by the template to return its data. This class \n provides some additional HTTP-specific template functions.");        
        bd.setValue("BeanDoc", "4.1.2");
        
        return bd;
    }

    // Create the additional bean info objects for the bean.
    private BeanInfo[] createAdditionalBeanInfo() {
        
        Vector bis = new Vector();
        BeanInfo bi = null;                
        
        //
        // Get the BeanInfo for each interface
        //          
        
        bi = null;
        try {
            bi = Introspector.getBeanInfo(org.teatrove.tea.runtime.UtilityContext.class);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }        
        
        if (bi != null) {    
            bis.addElement(bi);
        }            
                        
        BeanInfo[] additionalBeanInfo = null;
        if (bis.size() > 0) {
            additionalBeanInfo = new BeanInfo[bis.size()];
            bis.copyInto(additionalBeanInfo);
        }
        
        return additionalBeanInfo;
    }

    // Create the method descriptor objects for the bean.
    private MethodDescriptor[] createMethodDescriptors() {
                
        Class[] paramTypes = null;
        int paramIndex = 0;  
        ParameterDescriptor[] paramDescriptors = null;
        ParameterDescriptor pd = null;
        
        Vector mds = new Vector();
        Method m = null;
        MethodDescriptor md = null;

           
        
        //
        // debug 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("s");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("debug", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("debug");
            md.setDisplayName("debug");
            md.setShortDescription("Send a debug log message to the system logs.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // debug 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Throwable.class; 
        pd = new ParameterDescriptor();
        pd.setName("t");
        pd.setDisplayName("java.lang.Throwable"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("debug", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("debug");
            md.setDisplayName("debug");
            md.setShortDescription("Send a debug log throwable to the system logs.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // decodeParameter 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("str");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the string to encode"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("decodeParameter", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("decodeParameter");
            md.setDisplayName("decodeParameter");
            md.setShortDescription("Decodes a previously encoded URL.  See <b>encodeParameter()</b>");   
            
            mds.addElement(md);
        }            
           
        
        //
        // decodeParameter 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("str");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the string to encode"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("encoding");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the character encoding to use."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("decodeParameter", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("decodeParameter");
            md.setDisplayName("decodeParameter");
            md.setShortDescription("Decodes a previously encoded URL.  See <b>encodeParameter()</b>");   
            
            mds.addElement(md);
        }            
           
        
        //
        // encodeParameter 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("str");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the string to encode"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("encodeParameter", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("encodeParameter");
            md.setDisplayName("encodeParameter");
            md.setShortDescription("Encodes the given string so that it can be safely used in a URL. For\n example, \'?\' is encoded to \'%3f\'.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // encodeParameter 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("str");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the string to encode"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("encoding");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the character encoding to use."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("encodeParameter", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("encodeParameter");
            md.setDisplayName("encodeParameter");
            md.setShortDescription("Encodes the given string so that it can be safely used in a URL. For\n example, \'?\' is encoded to \'%3f\'.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // error 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("s");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("error", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("error");
            md.setDisplayName("error");
            md.setShortDescription("Send a error log message to the system logs.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // error 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Throwable.class; 
        pd = new ParameterDescriptor();
        pd.setName("t");
        pd.setDisplayName("java.lang.Throwable"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("error", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("error");
            md.setDisplayName("error");
            md.setShortDescription("Send a error log throwable to the system logs.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // fileExists 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("path");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the name of the file to test"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("fileExists", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("fileExists");
            md.setDisplayName("fileExists");
            md.setShortDescription("Tests if a file at the given path exists. If the servlet that is running\n the template has a root directory, it is used to determine the physical\n file path. If the servlet does not have a root directory set, it is\n assumed to be the root of the file system. If the path given to this\n function does not lead with a slash, the path is relative to the\n pathInfo variable from the request.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getRequest 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = HttpContext.class.getMethod("getRequest", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getRequest");
            md.setDisplayName("getRequest");
            md.setShortDescription("Gets an object that contains all the request information from the\n client.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getRequest 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("encoding");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the character encoding"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("getRequest", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getRequest");
            md.setDisplayName("getRequest");
            md.setShortDescription("Gets an object that contains all the request information from the\n client and all the parameters are converted using the specified\n character encoding.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // info 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("s");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("info", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("info");
            md.setDisplayName("info");
            md.setShortDescription("Send a info log message to the system logs.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // info 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Throwable.class; 
        pd = new ParameterDescriptor();
        pd.setName("t");
        pd.setDisplayName("java.lang.Throwable"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("info", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("info");
            md.setDisplayName("info");
            md.setShortDescription("Send a info log throwable to the system logs.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // insertFile 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("path");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the name of the file to insert"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("insertFile", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("insertFile");
            md.setDisplayName("insertFile");
            md.setShortDescription("Inserts the contents of the given file into the page output or not at\n all if the file does not exist or cannot be read. This function inserts\n the raw bytes from the file - no character conversion is applied.\n Consider using {@link readFile} in order to use character conversion.\n <p>\n If the servlet that is running the template has a root directory, it is \n used to determine the physical file path. If the servlet does not have\n a root directory set, it is assumed to be the root of the file system.\n If the path given to this function does not lead with a slash, the path\n is relative to the pathInfo variable from the request.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // insertPath 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("path");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the path from the servlet context to insert"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("insertPath", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("insertPath");
            md.setDisplayName("insertPath");
            md.setShortDescription("This function allows calling out of Tea to other view technologies (like JSP)\n It is not intended to replace the <b>call<b> keyword and will cause an error if \n used to call a Tea Template.\n \n Inserts the contents of the resource at the given path within the \n servlet context into the page output. If the resource does not exist \n or cannot be read, nothing is inserted. \n The given path must be relative to the servlet Context.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // insertURL 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("URL");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("insertURL", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("insertURL");
            md.setDisplayName("insertURL");
            md.setShortDescription("Inserts the contents of the resource at the given URL into the page\n output. If the resource does not exist or cannot be read, nothing is\n inserted. The given URL can be absolute or relative. This function\n inserts the raw bytes from the URL - no character conversion is applied.\n Consider using {@link readURL} in order to use character conversion.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // overrideOutput 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = boolean.class; 
        pd = new ParameterDescriptor();
        pd.setName("overridePermitted");
        pd.setDisplayName("boolean"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("overrideOutput", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("overrideOutput");
            md.setDisplayName("overrideOutput");  
            
            md.setHidden(true);    
            
            mds.addElement(md);
        }            
           
        
        //
        // readFile 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("path");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the name of the file to insert"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("readFile", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("readFile");
            md.setDisplayName("readFile");
            md.setShortDescription("Reads and returns the contents of the given file. If the file does not\n exist or cannot be read, an empty string is returned. This function\n differs from {@link insertFile} in that the character conversion is\n applied and the file\'s contents are returned.\n <p>\n If the servlet that is running the template has a root directory, it is \n used to determine the physical file path. If the servlet does not have\n a root directory set, it is assumed to be the root of the file system.\n If the path given to this function does not lead with a slash, the path\n is relative to the pathInfo variable from the request.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // readFile 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("path");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the name of the file to insert"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("encoding");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("character encoding"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("readFile", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("readFile");
            md.setDisplayName("readFile");
            md.setShortDescription("Reads and returns the contents of the given file. If the file does not\n exist or cannot be read, an empty string is returned. This function\n differs from {@link insertFile} in that the character conversion is\n applied and the file\'s contents are returned.\n <p>\n If the servlet that is running the template has a root directory, it is \n used to determine the physical file path. If the servlet does not have\n a root directory set, it is assumed to be the root of the file system.\n If the path given to this function does not lead with a slash, the path\n is relative to the pathInfo variable from the request.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // readPath 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("path");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the path from the servlet context to read"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("readPath", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("readPath");
            md.setDisplayName("readPath");
            md.setShortDescription("This function allows calling out of Tea to other view technologies (like JSP)\n It is not intended to replace the <b>call<b> keyword and will cause an error if \n used to call a Tea Template.\n \n Reads and returns the contents of the resource at the given path within \n the servlet context into the page output. If the resource does not exist \n or cannot be read, nothing is inserted. \n The given path must be relative to the servlet Context.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // readURL 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("URL");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("readURL", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("readURL");
            md.setDisplayName("readURL");
            md.setShortDescription("Reads and returns the contents of the given URL. If the URL does not\n exist or cannot be read, an empty string is returned. This function\n differs from {@link insertURL} in that the character conversion is\n applied and the resource\'s contents are returned.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // readURL 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("URL");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("encoding");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("character encoding"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("readURL", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("readURL");
            md.setDisplayName("readURL");
            md.setShortDescription("Reads and returns the contents of the given URL. If the URL does not\n exist or cannot be read, an empty string is returned. This function\n differs from {@link insertURL} in that the character conversion is\n applied and the resource\'s contents are returned.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // sendError 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("code");
        pd.setDisplayName("int"); 
        pd.setShortDescription("the error code int"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("sendError", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("sendError");
            md.setDisplayName("sendError");
            md.setShortDescription("Causes an error page to be generated using the given status code.\n Further template processing is aborted and any output already\n provided by the template is not sent.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // sendError 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("code");
        pd.setDisplayName("int"); 
        pd.setShortDescription("the error code int"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("message");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the error message"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("sendError", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("sendError");
            md.setDisplayName("sendError");
            md.setShortDescription("Causes an error page to be generated using the given status code and\n message. Further template processing is aborted and any output already\n provided by the template is not sent.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // sendRedirect 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("url");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the url to redirect to"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("sendRedirect", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("sendRedirect");
            md.setDisplayName("sendRedirect");
            md.setShortDescription("Creates a response that forces the client to redirect to the given URL.\n Further template processing is aborted and any output already provided\n by the template is not sent.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // setContentType 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("type");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the MIME type of the page"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("setContentType", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("setContentType");
            md.setDisplayName("setContentType");
            md.setShortDescription("Sets the MIME type of the page, like \"text/html\" or \"text/plain\". If\n another character encoding is desired, for internationalization, append\n charset property like this: \"text/html; charset=iso-8859-1\".");   
            
            mds.addElement(md);
        }            
           
        
        //
        // setHeader 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("name");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the name of the header"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.util.Date.class; 
        pd = new ParameterDescriptor();
        pd.setName("value");
        pd.setDisplayName("java.util.Date"); 
        pd.setShortDescription("the date value of the header"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("setHeader", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("setHeader");
            md.setDisplayName("setHeader");
            md.setShortDescription("An advanced function that sets the date value of an\n arbitrary HTTP response header.");   
            
            md.setExpert(true);                               
            
            mds.addElement(md);
        }            
           
        
        //
        // setHeader 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("name");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the name of the header"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("value");
        pd.setDisplayName("int"); 
        pd.setShortDescription("the int value of the header"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("setHeader", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("setHeader");
            md.setDisplayName("setHeader");
            md.setShortDescription("An advanced function that sets the integer value of an\n arbitrary HTTP response header.");   
            
            md.setExpert(true);                               
            
            mds.addElement(md);
        }            
           
        
        //
        // setHeader 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("name");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the name of the header"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("value");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the string value of the header"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("setHeader", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("setHeader");
            md.setDisplayName("setHeader");
            md.setShortDescription("An advanced function that sets the string value of an\n arbitrary HTTP response header.");   
            
            md.setExpert(true);                               
            
            mds.addElement(md);
        }            
           
        
        //
        // setStatus 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("code");
        pd.setDisplayName("int"); 
        pd.setShortDescription("the status code int"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("setStatus", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("setStatus");
            md.setDisplayName("setStatus");
            md.setShortDescription("Sets the response\'s HTTP status code, like 200 for OK or 404 for not\n found.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // setURLTimeout 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("timeout");
        pd.setDisplayName("long"); 
        pd.setShortDescription("max time to wait for URL operation to complete, in\n milliseconds"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("setURLTimeout", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("setURLTimeout");
            md.setDisplayName("setURLTimeout");
            md.setShortDescription("Requests to check, insert, or read URLs will timeout if the remote\n hosts doesn\'t respond in time. Call this function to explicitly set\n the timeout value.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // stealOutput 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.tea.runtime.OutputReceiver.class; 
        pd = new ParameterDescriptor();
        pd.setName("receiver");
        pd.setDisplayName("org.teatrove.tea.runtime.OutputReceiver"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = org.teatrove.tea.runtime.Substitution.class; 
        pd = new ParameterDescriptor();
        pd.setName("s");
        pd.setDisplayName("org.teatrove.tea.runtime.Substitution"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("stealOutput", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("stealOutput");
            md.setDisplayName("stealOutput");  
            
            md.setHidden(true);    
            
            mds.addElement(md);
        }            
           
        
        //
        // URLExists 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("URL");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("URLExists", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("URLExists");
            md.setDisplayName("URLExists");
            md.setShortDescription("Tests if a resource at the given URL exists. If the URL has no protocol\n specified, then a relative lookup is performed. If the relative URL\n begins with a slash, the lookup is performed with an absolute path on\n the this server. If the relative URL does not begin with a slash, then\n the lookup is performed with a relative path.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // warn 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("s");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("warn", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("warn");
            md.setDisplayName("warn");
            md.setShortDescription("Send a warn log message to the system logs.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // warn 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Throwable.class; 
        pd = new ParameterDescriptor();
        pd.setName("t");
        pd.setDisplayName("java.lang.Throwable"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("warn", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("warn");
            md.setDisplayName("warn");
            md.setShortDescription("Send a warn log throwable to the system logs.");   
            
            mds.addElement(md);
        }            
               
                         
        MethodDescriptor[] methodDescriptors = 
                                new MethodDescriptor[mds.size()];
        mds.copyInto(methodDescriptors);
                
        return methodDescriptors;
    }

    // Create the property descriptor objects for the bean.
    private PropertyDescriptor[] createPropertyDescriptors() {
                           
        PropertyDescriptor[] propertyDescriptors = new PropertyDescriptor[4];
        PropertyDescriptor pd = null;
        int propertyIndex = 0;          
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("request", HttpContext.class, "getRequest", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("request");
            pd.setShortDescription("An object that contains all the request information from the\n client.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("contentType", HttpContext.class, null, "setContentType");
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("contentType");
            pd.setShortDescription("The MIME type of the page, like \"text/html\" or \"text/plain\". If\n another character encoding is desired, for internationalization, append\n charset property like this: \"text/html; charset=iso-8859-1\".");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("status", HttpContext.class, null, "setStatus");
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("status");
            pd.setShortDescription("The response\'s HTTP status code, like 200 for OK or 404 for not\n found.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("URLTimeout", HttpContext.class, null, "setURLTimeout");
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("URLTimeout");
            pd.setShortDescription("Requests to check, insert, or read URLs will timeout if the remote\n hosts doesn\'t respond in time. Call this function to explicitly set\n the timeout value.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
        
        if (propertyDescriptors.length == 0) {
            propertyDescriptors = null;    
        }
        
        return propertyDescriptors;
    }

}