/*
 * TeaServletBeanInfo.java
 *
 * BeanDoc generated on Fri Mar 16 at 12:39:55 EDT 02012.
 * 
 * See TeaServlet.java for copyright information.
 */

package org.teatrove.teaservlet;

import java.beans.*;
import java.lang.reflect.*;

import java.util.Vector;

/**
 * The BeanInfo class describing TeaServlet. 
 *
 * @author Reece Wilton
 */
public class TeaServletBeanInfo extends SimpleBeanInfo {

    /** BeanDescriptor returned by the <code>getBeanDescriptor</code> 
        method */
    private BeanDescriptor mBeanDescriptor;

    /** BeanInfo array returned by the <code>getAdditionalBeanInfo</code> 
        method */
    private BeanInfo[] mAdditionalBeanInfo;

    /** MethodDescriptor array returned by the 
        <code>getMethodDescriptors</code> method */
    private MethodDescriptor[] mMethodDescriptors;

    /** PropertyDescriptor array returned by the 
        <code>getPropertyDescriptors</code> method */
    private PropertyDescriptor[] mPropertyDescriptors;
    
    /** The index of the default property */
    private int mDefaultPropertyIndex;


    /**
     * Creates a new TeaServletBeanInfo.
     */
    public TeaServletBeanInfo() {        
                          
        mDefaultPropertyIndex = -1;
        
    }
     
    /**
     * Returns a BeanDescriptor that describes TeaServlet.
     */    
    public BeanDescriptor getBeanDescriptor() {
        
        if (mBeanDescriptor == null) {
            mBeanDescriptor = createBeanDescriptor();       
        }

        return mBeanDescriptor;
    }

    /**
     * Returns a BeanInfo array containing BeanInfo object's for:<br>
     * <code>javax.servlet.http.HttpServlet</code><br>      
     */  
    public BeanInfo[] getAdditionalBeanInfo() {

        if (mAdditionalBeanInfo == null) {
            mAdditionalBeanInfo = createAdditionalBeanInfo();       
        }

        return mAdditionalBeanInfo;
    }

    /**    
     * Returns MethodDescriptors that describe the methods of 
     * TeaServlet.  Call the 
     * <code>getAdditionalBeanInfo</code> method to get the 
     * method descriptors of the superclass and interfaces.
     */ 
    public MethodDescriptor[] getMethodDescriptors() {

        if (mMethodDescriptors == null) {
            mMethodDescriptors = createMethodDescriptors();       
        }

        return mMethodDescriptors;
    }

    /**    
     * Returns a PropertyDescriptor array that describes the properties of 
     * TeaServlet.
     */ 
    public PropertyDescriptor[] getPropertyDescriptors() {

        if (mPropertyDescriptors == null) {
            mPropertyDescriptors = createPropertyDescriptors();     
        }

        return mPropertyDescriptors;
    }

    /**
     * Return the index of the default property.
     */
    public int getDefaultPropertyIndex() {
        return mDefaultPropertyIndex;
    }


    //
    // Non-public interface
    //

    // Create the bean descriptor for the bean.
    private BeanDescriptor createBeanDescriptor() {                        
        
        BeanDescriptor bd = 
            new BeanDescriptor(TeaServlet.class);
        
        bd.setName("TeaServlet");
        bd.setDisplayName("TeaServlet");
        bd.setShortDescription("The TeaServlet allows Tea templates to define dynamic web pages. The URI\n that is passed into the servlet determines what template will be called.\n Within the template, custom functions can be called that return JavaBeans.\n These functions are accessed via {@link Application Applications} that are\n configured to run in the TeaServlet.\n <p>\n The TeaServlet accepts the following initialization parameters:\n <ul>\n <li>properties.file - optional path to file with TeaServlet properties, in format used by {@link org.teatrove.teaservlet.util.PropertyParser}\n <li>template.path - path to the templates\n <li>template.classes - directory to save compiled templates\n <li>template.default - the default name for templates\n <li>template.file.encoding - character encoding of template source files\n <li>template.exception.guardian - when true, runtime exceptions during template execution don\'t abort page output\n <li>autocompile - when true, will compile the template when it is requested if the template has been updated (just like JSP!)\n <li>autocompile.recurse - when true (default), will compile any sub-template that has changed regardless of if the requested template has changed.  Only meaningful if autocompile=true\n <li>separator.query - override the query separator of \'?\'\n <li>separator.parameter - override the parameter separator of \'&\'\n <li>separator.value - override the parameter separator of \'=\'\n <li>log.enabled - turns on/off log (boolean)\n <li>log.debug - turns on/off log debug messages (boolean)\n <li>log.info - turns on/off log info messages (boolean)\n <li>log.warn - turns on/off log warning messages (boolean)\n <li>log.error - turns on/off log error messages (boolean)\n <li>log.max - the max log lines to keep in memory\n <li>applications.[name].class - the application class (required)\n <li>applications.[name].init.* - prefix for application specific initialization parameters\n <li>applications.[name].log.enabled - turns on/off application log (boolean)\n <li>applications.[name].log.debug - turns on/off application log debug messages (boolean)\n <li>applications.[name].log.info - turns on/off application log info messages (boolean)\n <li>applications.[name].log.warn - turns on/off application log warning messages (boolean)\n <li>applications.[name].log.error - turns on/off application log error messages (boolean)\n </ul>");        
        bd.setValue("BeanDoc", "4.1.2");
        
        return bd;
    }

    // Create the additional bean info objects for the bean.
    private BeanInfo[] createAdditionalBeanInfo() {
        
        Vector bis = new Vector();
        BeanInfo bi = null;                
        
        bi = null;
        try {
            // Get the BeanInfo for the superclass
            bi = Introspector.getBeanInfo(javax.servlet.http.HttpServlet.class);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }        
        
        if (bi != null) {    
            bis.addElement(bi);
        }                            
                        
        BeanInfo[] additionalBeanInfo = null;
        if (bis.size() > 0) {
            additionalBeanInfo = new BeanInfo[bis.size()];
            bis.copyInto(additionalBeanInfo);
        }
        
        return additionalBeanInfo;
    }

    // Create the method descriptor objects for the bean.
    private MethodDescriptor[] createMethodDescriptors() {
                
        Class[] paramTypes = null;
        int paramIndex = 0;  
        ParameterDescriptor[] paramDescriptors = null;
        ParameterDescriptor pd = null;
        
        Vector mds = new Vector();
        Method m = null;
        MethodDescriptor md = null;

           
        
        //
        // destroy 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TeaServlet.class.getMethod("destroy", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("destroy");
            md.setDisplayName("destroy");
            md.setShortDescription("Destroys the TeaServlet and the user\'s application.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getLog 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TeaServlet.class.getMethod("getLog", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getLog");
            md.setDisplayName("getLog");
            md.setShortDescription("Logger access.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getProperties 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TeaServlet.class.getMethod("getProperties", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getProperties");
            md.setDisplayName("getProperties");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getServletInfo 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TeaServlet.class.getMethod("getServletInfo", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getServletInfo");
            md.setDisplayName("getServletInfo");
            md.setShortDescription("Returns information about the TeaServlet.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // init 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = javax.servlet.ServletConfig.class; 
        pd = new ParameterDescriptor();
        pd.setName("config");
        pd.setDisplayName("javax.servlet.ServletConfig"); 
        pd.setShortDescription("the servlet config"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaServlet.class.getMethod("init", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("init");
            md.setDisplayName("init");
            md.setShortDescription("Initializes the TeaServlet. Creates the logger and loads the user\'s\n application.");   
            
            mds.addElement(md);
        }            
               
                         
        MethodDescriptor[] methodDescriptors = 
                                new MethodDescriptor[mds.size()];
        mds.copyInto(methodDescriptors);
                
        return methodDescriptors;
    }

    // Create the property descriptor objects for the bean.
    private PropertyDescriptor[] createPropertyDescriptors() {
                           
        PropertyDescriptor[] propertyDescriptors = new PropertyDescriptor[3];
        PropertyDescriptor pd = null;
        int propertyIndex = 0;          
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("log", TeaServlet.class, "getLog", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("log");
            pd.setShortDescription("Logger access.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("properties", TeaServlet.class, "getProperties", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("properties");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("servletInfo", TeaServlet.class, "getServletInfo", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("servletInfo");
            pd.setShortDescription("Information about the TeaServlet.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
        
        if (propertyDescriptors.length == 0) {
            propertyDescriptors = null;    
        }
        
        return propertyDescriptors;
    }

}