/*
 * TeaServletEngineBeanInfo.java
 *
 * BeanDoc generated on Fri Mar 16 at 12:39:55 EDT 02012.
 * 
 * See TeaServletEngine.java for copyright information.
 */

package org.teatrove.teaservlet;

import java.beans.*;
import java.lang.reflect.*;

import java.util.Vector;

/**
 * The BeanInfo class describing TeaServletEngine. 
 *
 * @author Brian S O'Neill
 */
public class TeaServletEngineBeanInfo extends SimpleBeanInfo {

    /** BeanDescriptor returned by the <code>getBeanDescriptor</code> 
        method */
    private BeanDescriptor mBeanDescriptor;

    /** BeanInfo array returned by the <code>getAdditionalBeanInfo</code> 
        method */
    private BeanInfo[] mAdditionalBeanInfo;

    /** MethodDescriptor array returned by the 
        <code>getMethodDescriptors</code> method */
    private MethodDescriptor[] mMethodDescriptors;

    /** PropertyDescriptor array returned by the 
        <code>getPropertyDescriptors</code> method */
    private PropertyDescriptor[] mPropertyDescriptors;
    
    /** The index of the default property */
    private int mDefaultPropertyIndex;


    /**
     * Creates a new TeaServletEngineBeanInfo.
     */
    public TeaServletEngineBeanInfo() {        
                          
        mDefaultPropertyIndex = -1;
        
    }
     
    /**
     * Returns a BeanDescriptor that describes TeaServletEngine.
     */    
    public BeanDescriptor getBeanDescriptor() {
        
        if (mBeanDescriptor == null) {
            mBeanDescriptor = createBeanDescriptor();       
        }

        return mBeanDescriptor;
    }

    /**
     * Returns a BeanInfo array containing BeanInfo object's for:<br>
     * <code>org.teatrove.teaservlet.ApplicationConfig</code><br>      
     */  
    public BeanInfo[] getAdditionalBeanInfo() {

        if (mAdditionalBeanInfo == null) {
            mAdditionalBeanInfo = createAdditionalBeanInfo();       
        }

        return mAdditionalBeanInfo;
    }

    /**    
     * Returns MethodDescriptors that describe the methods of 
     * TeaServletEngine.  Call the 
     * <code>getAdditionalBeanInfo</code> method to get the 
     * method descriptors of the superclass and interfaces.
     */ 
    public MethodDescriptor[] getMethodDescriptors() {

        if (mMethodDescriptors == null) {
            mMethodDescriptors = createMethodDescriptors();       
        }

        return mMethodDescriptors;
    }

    /**    
     * Returns a PropertyDescriptor array that describes the properties of 
     * TeaServletEngine.
     */ 
    public PropertyDescriptor[] getPropertyDescriptors() {

        if (mPropertyDescriptors == null) {
            mPropertyDescriptors = createPropertyDescriptors();     
        }

        return mPropertyDescriptors;
    }

    /**
     * Return the index of the default property.
     */
    public int getDefaultPropertyIndex() {
        return mDefaultPropertyIndex;
    }


    //
    // Non-public interface
    //

    // Create the bean descriptor for the bean.
    private BeanDescriptor createBeanDescriptor() {                        
        
        BeanDescriptor bd = 
            new BeanDescriptor(TeaServletEngine.class);
        
        bd.setName("TeaServletEngine");
        bd.setDisplayName("TeaServletEngine");
        bd.setShortDescription("This interface allows other servlets to create\n {@link TeaServletTransaction TeaServletTransactions}. When the TeaServlet is\n initialized, it adds an attribute to its ServletContext named\n \"org.teatrove.teaservlet.TeaServletEngine\". The attribute\'s value is a\n TeaServletEngine array. The number of array elements matches the number of\n times a TeaServlet is configured in. Use TeaServletEngine\'s name to\n distinguish between different instances.\n <p>\n Servlets that request a TeaServletTransaction should generally let all\n output be handled by it. This is because it will try to set headers and use\n a servlet output stream.");        
        bd.setValue("BeanDoc", "4.1.2");
        
        return bd;
    }

    // Create the additional bean info objects for the bean.
    private BeanInfo[] createAdditionalBeanInfo() {
        
        Vector bis = new Vector();
        BeanInfo bi = null;                
        
        //
        // Get the BeanInfo for each interface
        //          
        
        bi = null;
        try {
            bi = Introspector.getBeanInfo(org.teatrove.teaservlet.ApplicationConfig.class);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }        
        
        if (bi != null) {    
            bis.addElement(bi);
        }            
                        
        BeanInfo[] additionalBeanInfo = null;
        if (bis.size() > 0) {
            additionalBeanInfo = new BeanInfo[bis.size()];
            bis.copyInto(additionalBeanInfo);
        }
        
        return additionalBeanInfo;
    }

    // Create the method descriptor objects for the bean.
    private MethodDescriptor[] createMethodDescriptors() {
                
        Class[] paramTypes = null;
        int paramIndex = 0;  
        ParameterDescriptor[] paramDescriptors = null;
        ParameterDescriptor pd = null;
        
        Vector mds = new Vector();
        Method m = null;
        MethodDescriptor md = null;

           
        
        //
        // createTransaction 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = javax.servlet.http.HttpServletRequest.class; 
        pd = new ParameterDescriptor();
        pd.setName("request");
        pd.setDisplayName("javax.servlet.http.HttpServletRequest"); 
        pd.setShortDescription("HttpServletRequest used for building ApplicationRequest."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = javax.servlet.http.HttpServletResponse.class; 
        pd = new ParameterDescriptor();
        pd.setName("response");
        pd.setDisplayName("javax.servlet.http.HttpServletResponse"); 
        pd.setShortDescription("HttpServletResponse used for building\n ApplicationResponse."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaServletEngine.class.getMethod("createTransaction", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("createTransaction");
            md.setDisplayName("createTransaction");
            md.setShortDescription("Creates a TeaServletTransaction instance for the given request/response\n pair and returns it.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // createTransaction 
        //
        paramTypes = new Class[3];
        paramDescriptors = new ParameterDescriptor[3];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = javax.servlet.http.HttpServletRequest.class; 
        pd = new ParameterDescriptor();
        pd.setName("request");
        pd.setDisplayName("javax.servlet.http.HttpServletRequest"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = javax.servlet.http.HttpServletResponse.class; 
        pd = new ParameterDescriptor();
        pd.setName("response");
        pd.setDisplayName("javax.servlet.http.HttpServletResponse"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = boolean.class; 
        pd = new ParameterDescriptor();
        pd.setName("lookupTemplate");
        pd.setDisplayName("boolean"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaServletEngine.class.getMethod("createTransaction", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("createTransaction");
            md.setDisplayName("createTransaction");  
            
            mds.addElement(md);
        }            
           
        
        //
        // destroy 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TeaServletEngine.class.getMethod("destroy", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("destroy");
            md.setDisplayName("destroy");  
            
            mds.addElement(md);
        }            
           
        
        //
        // findTemplate 
        //
        paramTypes = new Class[3];
        paramDescriptors = new ParameterDescriptor[3];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("uri");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = javax.servlet.http.HttpServletRequest.class; 
        pd = new ParameterDescriptor();
        pd.setName("request");
        pd.setDisplayName("javax.servlet.http.HttpServletRequest"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = javax.servlet.http.HttpServletResponse.class; 
        pd = new ParameterDescriptor();
        pd.setName("response");
        pd.setDisplayName("javax.servlet.http.HttpServletResponse"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaServletEngine.class.getMethod("findTemplate", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("findTemplate");
            md.setDisplayName("findTemplate");  
            
            mds.addElement(md);
        }            
           
        
        //
        // findTemplate 
        //
        paramTypes = new Class[4];
        paramDescriptors = new ParameterDescriptor[4];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("uri");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = javax.servlet.http.HttpServletRequest.class; 
        pd = new ParameterDescriptor();
        pd.setName("request");
        pd.setDisplayName("javax.servlet.http.HttpServletRequest"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = javax.servlet.http.HttpServletResponse.class; 
        pd = new ParameterDescriptor();
        pd.setName("response");
        pd.setDisplayName("javax.servlet.http.HttpServletResponse"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = org.teatrove.tea.engine.TemplateSource.class; 
        pd = new ParameterDescriptor();
        pd.setName("templateSrc");
        pd.setDisplayName("org.teatrove.tea.engine.TemplateSource"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaServletEngine.class.getMethod("findTemplate", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("findTemplate");
            md.setDisplayName("findTemplate");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getApplicationDepot 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TeaServletEngine.class.getMethod("getApplicationDepot", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getApplicationDepot");
            md.setDisplayName("getApplicationDepot");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getAssetEngine 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TeaServletEngine.class.getMethod("getAssetEngine", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getAssetEngine");
            md.setDisplayName("getAssetEngine");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getLogEvents 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TeaServletEngine.class.getMethod("getLogEvents", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getLogEvents");
            md.setDisplayName("getLogEvents");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getProperties 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TeaServletEngine.class.getMethod("getProperties", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getProperties");
            md.setDisplayName("getProperties");
            md.setShortDescription("Returns initialization parameters in an easier to use map format.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getTemplatePaths 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TeaServletEngine.class.getMethod("getTemplatePaths", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTemplatePaths");
            md.setDisplayName("getTemplatePaths");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getTemplateSource 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TeaServletEngine.class.getMethod("getTemplateSource", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTemplateSource");
            md.setDisplayName("getTemplateSource");  
            
            mds.addElement(md);
        }            
           
        
        //
        // reloadContextAndTemplates 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = boolean.class; 
        pd = new ParameterDescriptor();
        pd.setName("all");
        pd.setDisplayName("boolean"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaServletEngine.class.getMethod("reloadContextAndTemplates", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("reloadContextAndTemplates");
            md.setDisplayName("reloadContextAndTemplates");  
            
            mds.addElement(md);
        }            
               
                         
        MethodDescriptor[] methodDescriptors = 
                                new MethodDescriptor[mds.size()];
        mds.copyInto(methodDescriptors);
                
        return methodDescriptors;
    }

    // Create the property descriptor objects for the bean.
    private PropertyDescriptor[] createPropertyDescriptors() {
                           
        PropertyDescriptor[] propertyDescriptors = new PropertyDescriptor[6];
        PropertyDescriptor pd = null;
        int propertyIndex = 0;          
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("applicationDepot", TeaServletEngine.class, "getApplicationDepot", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("applicationDepot");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("assetEngine", TeaServletEngine.class, "getAssetEngine", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("assetEngine");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("logEvents", TeaServletEngine.class, "getLogEvents", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("logEvents");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("properties", TeaServletEngine.class, "getProperties", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("properties");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("templatePaths", TeaServletEngine.class, "getTemplatePaths", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("templatePaths");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("templateSource", TeaServletEngine.class, "getTemplateSource", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("templateSource");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
        
        if (propertyDescriptors.length == 0) {
            propertyDescriptors = null;    
        }
        
        return propertyDescriptors;
    }

}