/*
 * AggregateStatsBeanInfo.java
 *
 * BeanDoc generated on Fri Mar 16 at 12:39:55 EDT 02012.
 * 
 * See AggregateStats.java for copyright information.
 */

package org.teatrove.teaservlet.stats;

import java.beans.*;
import java.lang.reflect.*;

import java.util.Vector;

/**
 * The BeanInfo class describing AggregateStats. 
 *
 * @author Scott Jappinen
 */
public class AggregateStatsBeanInfo extends SimpleBeanInfo {

    /** BeanDescriptor returned by the <code>getBeanDescriptor</code> 
        method */
    private BeanDescriptor mBeanDescriptor;

    /** BeanInfo array returned by the <code>getAdditionalBeanInfo</code> 
        method */
    private BeanInfo[] mAdditionalBeanInfo;

    /** MethodDescriptor array returned by the 
        <code>getMethodDescriptors</code> method */
    private MethodDescriptor[] mMethodDescriptors;

    /** PropertyDescriptor array returned by the 
        <code>getPropertyDescriptors</code> method */
    private PropertyDescriptor[] mPropertyDescriptors;
    
    /** The index of the default property */
    private int mDefaultPropertyIndex;


    /**
     * Creates a new AggregateStatsBeanInfo.
     */
    public AggregateStatsBeanInfo() {        
                          
        mDefaultPropertyIndex = -1;
        
    }
     
    /**
     * Returns a BeanDescriptor that describes AggregateStats.
     */    
    public BeanDescriptor getBeanDescriptor() {
        
        if (mBeanDescriptor == null) {
            mBeanDescriptor = createBeanDescriptor();       
        }

        return mBeanDescriptor;
    }

    /**
     * Returns a BeanInfo array containing BeanInfo object's for:<br>
     * <code>java.lang.Object</code><br>
     * <code>java.lang.Cloneable</code><br>      
     */  
    public BeanInfo[] getAdditionalBeanInfo() {

        if (mAdditionalBeanInfo == null) {
            mAdditionalBeanInfo = createAdditionalBeanInfo();       
        }

        return mAdditionalBeanInfo;
    }

    /**    
     * Returns MethodDescriptors that describe the methods of 
     * AggregateStats.  Call the 
     * <code>getAdditionalBeanInfo</code> method to get the 
     * method descriptors of the superclass and interfaces.
     */ 
    public MethodDescriptor[] getMethodDescriptors() {

        if (mMethodDescriptors == null) {
            mMethodDescriptors = createMethodDescriptors();       
        }

        return mMethodDescriptors;
    }

    /**    
     * Returns a PropertyDescriptor array that describes the properties of 
     * AggregateStats.
     */ 
    public PropertyDescriptor[] getPropertyDescriptors() {

        if (mPropertyDescriptors == null) {
            mPropertyDescriptors = createPropertyDescriptors();     
        }

        return mPropertyDescriptors;
    }

    /**
     * Return the index of the default property.
     */
    public int getDefaultPropertyIndex() {
        return mDefaultPropertyIndex;
    }


    //
    // Non-public interface
    //

    // Create the bean descriptor for the bean.
    private BeanDescriptor createBeanDescriptor() {                        
        
        BeanDescriptor bd = 
            new BeanDescriptor(AggregateStats.class);
        
        bd.setName("AggregateStats");
        bd.setDisplayName("AggregateStats");
        bd.setShortDescription("");        
        bd.setValue("BeanDoc", "4.1.2");
        
        return bd;
    }

    // Create the additional bean info objects for the bean.
    private BeanInfo[] createAdditionalBeanInfo() {
        
        Vector bis = new Vector();
        BeanInfo bi = null;                
        
        //
        // Get the BeanInfo for each interface
        //          
        
        bi = null;
        try {
            bi = Introspector.getBeanInfo(java.lang.Cloneable.class);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }        
        
        if (bi != null) {    
            bis.addElement(bi);
        }            
        
        bi = null;
        try {
            // Get the BeanInfo for the superclass
            bi = Introspector.getBeanInfo(java.lang.Object.class);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }        
        
        if (bi != null) {    
            bis.addElement(bi);
        }                            
                        
        BeanInfo[] additionalBeanInfo = null;
        if (bis.size() > 0) {
            additionalBeanInfo = new BeanInfo[bis.size()];
            bis.copyInto(additionalBeanInfo);
        }
        
        return additionalBeanInfo;
    }

    // Create the method descriptor objects for the bean.
    private MethodDescriptor[] createMethodDescriptors() {
                
        Class[] paramTypes = null;
        int paramIndex = 0;  
        ParameterDescriptor[] paramDescriptors = null;
        ParameterDescriptor pd = null;
        
        Vector mds = new Vector();
        Method m = null;
        MethodDescriptor md = null;

           
        
        //
        // clone 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AggregateStats.class.getMethod("clone", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("clone");
            md.setDisplayName("clone");
            md.setShortDescription("Returns a deep clone of this object.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getAbsoluteRange 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AggregateStats.class.getMethod("getAbsoluteRange", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getAbsoluteRange");
            md.setDisplayName("getAbsoluteRange");
            md.setShortDescription("<p>\n Returns the upper whisker for a boxplot.\n </p>\n\n <p>\n \\(\n \\text{upper whisker} = F_U + 1.5d_F\n \\)\n </p>");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getArithmeticMean 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AggregateStats.class.getMethod("getArithmeticMean", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getArithmeticMean");
            md.setDisplayName("getArithmeticMean");
            md.setShortDescription("<p>\n Returns the arithmethic mean of the data.\n </p>\n\n <p>\n \\(\\text{arithmethic mean} = E(X) = \\mu = \\frac{1}{n}\\sum_{i=0}^{n-1}x_i\\)\n </p>\n\n <p>\n <a href=\"http://en.wikipedia.org/wiki/Arithmetic_mean\">From Wikipedia</a> -\n The arithmetic mean, often referred to as simply the mean or\n average when the context is clear, is a method to derive the central\n tendency of a sample space.\n </p>");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getLowerQuartile 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AggregateStats.class.getMethod("getLowerQuartile", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getLowerQuartile");
            md.setDisplayName("getLowerQuartile");
            md.setShortDescription("<p>\n Return the lower quartile (forth).\n </p>\n\n <p>\n \\(\n F_L=\\frac{1}{2}\\{x_{(\\text{j})} + x_{(\\text{j+1})}\\}\n \\;\\; \\text{where} \\;\\;\n j = \\text{[depth of forth]}\n \\)\n </p>");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getLowerWhisker 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AggregateStats.class.getMethod("getLowerWhisker", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getLowerWhisker");
            md.setDisplayName("getLowerWhisker");
            md.setShortDescription("<p>\n Returns the lower outside whisker for a boxplot.\n </p>\n\n <p>\n \\(\n \\text{lower whisker} = F_L - 1.5d_F\n \\)\n </p>");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getMax 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AggregateStats.class.getMethod("getMax", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getMax");
            md.setDisplayName("getMax");
            md.setShortDescription("Returns the maximum value found in the data.\n\n <p>\n \\(\\max x\\)\n </p>");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getMedian 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AggregateStats.class.getMethod("getMedian", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getMedian");
            md.setDisplayName("getMedian");
            md.setShortDescription("<p>\n Returns the median of all values.\n </p>\n\n <p>\n <a href=\"http://en.wikipedia.org/wiki/Median\">From Wikipedia</a> -\n In probability theory and statistics, a median is described as the numeric\n value separating the higher half of a sample, a topics, or a probability\n distribution, from the lower half. The median of a finite list of numbers\n can be found by arranging all the observations from lowest value to highest\n value and picking the middle one. If there is an even number of observations,\n then there is no single middle value; the median is then usually defined to\n be the mean of the two middle values.\n </p>\n\n <p>\n Efficient computation of the sample median\n </p>\n\n </p>\n Even though sorting n items requires \\(O(n \\log n)\\) operations, selection algorithms\n can compute the kth-smallest of n items (e.g., the median) with only \\(O(n)\\) operations.\n </p>\n\n <p>\n The default implementation for this method uses a selection operation that computes\n the median in worst case \\(O(n)\\).\n </p>\n\n <p>\n For odd number of items then the \\(((n+1)/2)th\\) item is to be selected. For an even\n number of items the \\((n/2)th\\) item is to be averaged with the \\((n/2 + 1)th\\) item.\n </p>");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getMin 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AggregateStats.class.getMethod("getMin", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getMin");
            md.setDisplayName("getMin");
            md.setShortDescription("<p>\n Returns the minimum value found in the data.\n </p>\n\n <p>\n \\(\\min x\\)\n </p>");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getStandardDeviation 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AggregateStats.class.getMethod("getStandardDeviation", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getStandardDeviation");
            md.setDisplayName("getStandardDeviation");
            md.setShortDescription("<p>\n Returns the standard deviation of all values.\n </p>\n\n <p>\n <a href=\"http://en.wikipedia.org/wiki/Standard_Deviation\">From Wikipedia</a> -\n Standard deviation is a widely used measurement of variability or diversity\n used in statistics and probability theory. It shows how much variation or\n \"dispersion\" there is from the \"average\" (mean, or expected/budgeted value).\n A low standard deviation indicates that the data points tend to be very close\n to the mean, whereas high standard deviation indicates that the data are\n spread out over a large range of values.\n </p>\n\n <p>\n In general, the standard deviation defined by:\n </p>\n\n <p>\n \\(\\text{standard deviation}=\\sigma = \\sqrt{\\frac{1}{n}\\sum_{i=0}^{n-1} (x_i-\\mu)^{2}}\\)\n </p>\n\n <p>\n where\n </p>\n\n <p>\n \\(\\mu = \\frac{1}{n}\\sum_{i=0}^{n-1}x_i\\)\n </p>");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getSum 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AggregateStats.class.getMethod("getSum", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getSum");
            md.setDisplayName("getSum");
            md.setShortDescription("<p>\n Returns the sum of the data.\n </p>\n\n <p>\n \\(\\text{sum} = \\sum_{i=0}^{n-1}x_i\\)\n </p>");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getUpperQuartile 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AggregateStats.class.getMethod("getUpperQuartile", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getUpperQuartile");
            md.setDisplayName("getUpperQuartile");
            md.setShortDescription("<p>\n Return the upper quartile (forth).\n </p>\n\n <p>\n \\(\n F_U=\\frac{1}{2}\\{x_{(j)} + x_{(x_{j+1})}\\}\n \\;\\; \\text{where} \\;\\;\n j = \\text{[depth of median]} +\\text{[depth of forth]}\n \\)\n </p>");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getUpperWhisker 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AggregateStats.class.getMethod("getUpperWhisker", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getUpperWhisker");
            md.setDisplayName("getUpperWhisker");
            md.setShortDescription("<p>\n Returns the upper whisker for a boxplot.\n </p>\n\n <p>\n \\(\n \\text{upper whisker} = F_U + 1.5d_F\n \\)\n </p>");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getVariance 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AggregateStats.class.getMethod("getVariance", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getVariance");
            md.setDisplayName("getVariance");
            md.setShortDescription("<p>\n Returns the variance.\n </p>\n\n <p>\n <a href=\"http://en.wikipedia.org/wiki/Variance\">From Wikipedia</a> -\n The variance of a random variable or distribution is the expectation,\n or mean, of the squared deviation of that variable from its expected\n value or mean. Thus the variance is a measure of the amount of variation\n of the values of that variable, taking account of all possible values\n and their probabilities or weightings (not just the extremes which\n give the range).\n </p>\n\n <p>\n In general, the topics variance of a finite topics of size N is given by:\n </p>\n\n <p>\n \\(\\text{variance} = \\sigma^{2} = \\frac{1}{n}\\sum_{i=0}^{n-1} (x_i-\\mu)^{2}\\)\n </p>\n\n <p>\n where\n </p>\n\n <p>\n \\(\\mu = \\frac{1}{n}\\sum_{i=0}^{n-1}x_i\\)\n </p>\n\n <p>\n is the topics mean.\n </p>");   
            
            mds.addElement(md);
        }            
           
        
        //
        // reset 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = AggregateStats.class.getMethod("reset", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("reset");
            md.setDisplayName("reset");
            md.setShortDescription("Resets the statistics in this aggregate interval.");   
            
            mds.addElement(md);
        }            
               
                         
        MethodDescriptor[] methodDescriptors = 
                                new MethodDescriptor[mds.size()];
        mds.copyInto(methodDescriptors);
                
        return methodDescriptors;
    }

    // Create the property descriptor objects for the bean.
    private PropertyDescriptor[] createPropertyDescriptors() {
                           
        PropertyDescriptor[] propertyDescriptors = new PropertyDescriptor[12];
        PropertyDescriptor pd = null;
        int propertyIndex = 0;          
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("absoluteRange", AggregateStats.class, "getAbsoluteRange", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("absoluteRange");
            pd.setShortDescription("<p>\n Returns the upper whisker for a boxplot.\n </p>\n\n <p>\n \\(\n \\text{upper whisker} = F_U + 1.5d_F\n \\)\n </p>");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("arithmeticMean", AggregateStats.class, "getArithmeticMean", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("arithmeticMean");
            pd.setShortDescription("<p>\n Returns the arithmethic mean of the data.\n </p>\n\n <p>\n \\(\\text{arithmethic mean} = E(X) = \\mu = \\frac{1}{n}\\sum_{i=0}^{n-1}x_i\\)\n </p>\n\n <p>\n <a href=\"http://en.wikipedia.org/wiki/Arithmetic_mean\">From Wikipedia</a> -\n The arithmetic mean, often referred to as simply the mean or\n average when the context is clear, is a method to derive the central\n tendency of a sample space.\n </p>");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("lowerQuartile", AggregateStats.class, "getLowerQuartile", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("lowerQuartile");
            pd.setShortDescription("<p>\n Return the lower quartile (forth).\n </p>\n\n <p>\n \\(\n F_L=\\frac{1}{2}\\{x_{(\\text{j})} + x_{(\\text{j+1})}\\}\n \\;\\; \\text{where} \\;\\;\n j = \\text{[depth of forth]}\n \\)\n </p>");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("lowerWhisker", AggregateStats.class, "getLowerWhisker", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("lowerWhisker");
            pd.setShortDescription("<p>\n Returns the lower outside whisker for a boxplot.\n </p>\n\n <p>\n \\(\n \\text{lower whisker} = F_L - 1.5d_F\n \\)\n </p>");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("max", AggregateStats.class, "getMax", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("max");
            pd.setShortDescription("The maximum value found in the data.\n\n <p>\n \\(\\max x\\)\n </p>");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("median", AggregateStats.class, "getMedian", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("median");
            pd.setShortDescription("<p>\n Returns the median of all values.\n </p>\n\n <p>\n <a href=\"http://en.wikipedia.org/wiki/Median\">From Wikipedia</a> -\n In probability theory and statistics, a median is described as the numeric\n value separating the higher half of a sample, a topics, or a probability\n distribution, from the lower half. The median of a finite list of numbers\n can be found by arranging all the observations from lowest value to highest\n value and picking the middle one. If there is an even number of observations,\n then there is no single middle value; the median is then usually defined to\n be the mean of the two middle values.\n </p>\n\n <p>\n Efficient computation of the sample median\n </p>\n\n </p>\n Even though sorting n items requires \\(O(n \\log n)\\) operations, selection algorithms\n can compute the kth-smallest of n items (e.g., the median) with only \\(O(n)\\) operations.\n </p>\n\n <p>\n The default implementation for this method uses a selection operation that computes\n the median in worst case \\(O(n)\\).\n </p>\n\n <p>\n For odd number of items then the \\(((n+1)/2)th\\) item is to be selected. For an even\n number of items the \\((n/2)th\\) item is to be averaged with the \\((n/2 + 1)th\\) item.\n </p>");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("min", AggregateStats.class, "getMin", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("min");
            pd.setShortDescription("<p>\n Returns the minimum value found in the data.\n </p>\n\n <p>\n \\(\\min x\\)\n </p>");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("standardDeviation", AggregateStats.class, "getStandardDeviation", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("standardDeviation");
            pd.setShortDescription("<p>\n Returns the standard deviation of all values.\n </p>\n\n <p>\n <a href=\"http://en.wikipedia.org/wiki/Standard_Deviation\">From Wikipedia</a> -\n Standard deviation is a widely used measurement of variability or diversity\n used in statistics and probability theory. It shows how much variation or\n \"dispersion\" there is from the \"average\" (mean, or expected/budgeted value).\n A low standard deviation indicates that the data points tend to be very close\n to the mean, whereas high standard deviation indicates that the data are\n spread out over a large range of values.\n </p>\n\n <p>\n In general, the standard deviation defined by:\n </p>\n\n <p>\n \\(\\text{standard deviation}=\\sigma = \\sqrt{\\frac{1}{n}\\sum_{i=0}^{n-1} (x_i-\\mu)^{2}}\\)\n </p>\n\n <p>\n where\n </p>\n\n <p>\n \\(\\mu = \\frac{1}{n}\\sum_{i=0}^{n-1}x_i\\)\n </p>");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("sum", AggregateStats.class, "getSum", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("sum");
            pd.setShortDescription("<p>\n Returns the sum of the data.\n </p>\n\n <p>\n \\(\\text{sum} = \\sum_{i=0}^{n-1}x_i\\)\n </p>");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("upperQuartile", AggregateStats.class, "getUpperQuartile", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("upperQuartile");
            pd.setShortDescription("<p>\n Return the upper quartile (forth).\n </p>\n\n <p>\n \\(\n F_U=\\frac{1}{2}\\{x_{(j)} + x_{(x_{j+1})}\\}\n \\;\\; \\text{where} \\;\\;\n j = \\text{[depth of median]} +\\text{[depth of forth]}\n \\)\n </p>");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("upperWhisker", AggregateStats.class, "getUpperWhisker", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("upperWhisker");
            pd.setShortDescription("<p>\n Returns the upper whisker for a boxplot.\n </p>\n\n <p>\n \\(\n \\text{upper whisker} = F_U + 1.5d_F\n \\)\n </p>");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("variance", AggregateStats.class, "getVariance", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("variance");
            pd.setShortDescription("<p>\n Returns the variance.\n </p>\n\n <p>\n <a href=\"http://en.wikipedia.org/wiki/Variance\">From Wikipedia</a> -\n The variance of a random variable or distribution is the expectation,\n or mean, of the squared deviation of that variable from its expected\n value or mean. Thus the variance is a measure of the amount of variation\n of the values of that variable, taking account of all possible values\n and their probabilities or weightings (not just the extremes which\n give the range).\n </p>\n\n <p>\n In general, the topics variance of a finite topics of size N is given by:\n </p>\n\n <p>\n \\(\\text{variance} = \\sigma^{2} = \\frac{1}{n}\\sum_{i=0}^{n-1} (x_i-\\mu)^{2}\\)\n </p>\n\n <p>\n where\n </p>\n\n <p>\n \\(\\mu = \\frac{1}{n}\\sum_{i=0}^{n-1}x_i\\)\n </p>\n\n <p>\n is the topics mean.\n </p>");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
        
        if (propertyDescriptors.length == 0) {
            propertyDescriptors = null;    
        }
        
        return propertyDescriptors;
    }

}