/*
 * TeaServletRequestStatsBeanInfo.java
 *
 * BeanDoc generated on Fri Mar 16 at 12:39:55 EDT 02012.
 * 
 * See TeaServletRequestStats.java for copyright information.
 */

package org.teatrove.teaservlet.stats;

import java.beans.*;
import java.lang.reflect.*;

import java.util.Vector;

/**
 * The BeanInfo class describing TeaServletRequestStats. 
 *
 * @author Scott Jappinen
 */
public class TeaServletRequestStatsBeanInfo extends SimpleBeanInfo {

    /** BeanDescriptor returned by the <code>getBeanDescriptor</code> 
        method */
    private BeanDescriptor mBeanDescriptor;

    /** BeanInfo array returned by the <code>getAdditionalBeanInfo</code> 
        method */
    private BeanInfo[] mAdditionalBeanInfo;

    /** MethodDescriptor array returned by the 
        <code>getMethodDescriptors</code> method */
    private MethodDescriptor[] mMethodDescriptors;

    /** PropertyDescriptor array returned by the 
        <code>getPropertyDescriptors</code> method */
    private PropertyDescriptor[] mPropertyDescriptors;
    
    /** The index of the default property */
    private int mDefaultPropertyIndex;


    /**
     * Creates a new TeaServletRequestStatsBeanInfo.
     */
    public TeaServletRequestStatsBeanInfo() {        
                          
        mDefaultPropertyIndex = -1;
        
    }
     
    /**
     * Returns a BeanDescriptor that describes TeaServletRequestStats.
     */    
    public BeanDescriptor getBeanDescriptor() {
        
        if (mBeanDescriptor == null) {
            mBeanDescriptor = createBeanDescriptor();       
        }

        return mBeanDescriptor;
    }

    /**
     * Returns a BeanInfo array containing BeanInfo object's for:<br>
     * <code>java.lang.Object</code><br>      
     */  
    public BeanInfo[] getAdditionalBeanInfo() {

        if (mAdditionalBeanInfo == null) {
            mAdditionalBeanInfo = createAdditionalBeanInfo();       
        }

        return mAdditionalBeanInfo;
    }

    /**    
     * Returns MethodDescriptors that describe the methods of 
     * TeaServletRequestStats.  Call the 
     * <code>getAdditionalBeanInfo</code> method to get the 
     * method descriptors of the superclass and interfaces.
     */ 
    public MethodDescriptor[] getMethodDescriptors() {

        if (mMethodDescriptors == null) {
            mMethodDescriptors = createMethodDescriptors();       
        }

        return mMethodDescriptors;
    }

    /**    
     * Returns a PropertyDescriptor array that describes the properties of 
     * TeaServletRequestStats.
     */ 
    public PropertyDescriptor[] getPropertyDescriptors() {

        if (mPropertyDescriptors == null) {
            mPropertyDescriptors = createPropertyDescriptors();     
        }

        return mPropertyDescriptors;
    }

    /**
     * Return the index of the default property.
     */
    public int getDefaultPropertyIndex() {
        return mDefaultPropertyIndex;
    }


    //
    // Non-public interface
    //

    // Create the bean descriptor for the bean.
    private BeanDescriptor createBeanDescriptor() {                        
        
        BeanDescriptor bd = 
            new BeanDescriptor(TeaServletRequestStats.class);
        
        bd.setName("TeaServletRequestStats");
        bd.setDisplayName("TeaServletRequestStats");
        bd.setShortDescription("This class functions as the mediator for handling all http request\n level statistics gathering and derivation.\n \n This class logs template requests with the TemplateStats object\n associated with a given template.");        
        bd.setValue("BeanDoc", "4.1.2");
        
        return bd;
    }

    // Create the additional bean info objects for the bean.
    private BeanInfo[] createAdditionalBeanInfo() {
        
        Vector bis = new Vector();
        BeanInfo bi = null;                
        
        bi = null;
        try {
            // Get the BeanInfo for the superclass
            bi = Introspector.getBeanInfo(java.lang.Object.class);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }        
        
        if (bi != null) {    
            bis.addElement(bi);
        }                            
                        
        BeanInfo[] additionalBeanInfo = null;
        if (bis.size() > 0) {
            additionalBeanInfo = new BeanInfo[bis.size()];
            bis.copyInto(additionalBeanInfo);
        }
        
        return additionalBeanInfo;
    }

    // Create the method descriptor objects for the bean.
    private MethodDescriptor[] createMethodDescriptors() {
                
        Class[] paramTypes = null;
        int paramIndex = 0;  
        ParameterDescriptor[] paramDescriptors = null;
        ParameterDescriptor pd = null;
        
        Vector mds = new Vector();
        Method m = null;
        MethodDescriptor md = null;

           
        
        //
        // applyProperties 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.trove.util.PropertyMap.class; 
        pd = new ParameterDescriptor();
        pd.setName("properties");
        pd.setDisplayName("org.teatrove.trove.util.PropertyMap"); 
        pd.setShortDescription(""); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaServletRequestStats.class.getMethod("applyProperties", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("applyProperties");
            md.setDisplayName("applyProperties");
            md.setShortDescription("This method applies properties from a stats block\n in the tea servlet config.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getAggregateWindowSize 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TeaServletRequestStats.class.getMethod("getAggregateWindowSize", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getAggregateWindowSize");
            md.setDisplayName("getAggregateWindowSize");
            md.setShortDescription("Returns the aggregate window size.\n \n This defines the number of aggregate intervals that will be\n kept in memory for all templates.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getInstance 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TeaServletRequestStats.class.getMethod("getInstance", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getInstance");
            md.setDisplayName("getInstance");
            md.setShortDescription("Returns a static instance of TeaServletRequestStats.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getRawWindowSize 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TeaServletRequestStats.class.getMethod("getRawWindowSize", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getRawWindowSize");
            md.setDisplayName("getRawWindowSize");
            md.setShortDescription("Returns the raw window size.\n \n This defines the number of raw data entries that will be\n kept in memory for all templates.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getStatisticsMap 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TeaServletRequestStats.class.getMethod("getStatisticsMap", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getStatisticsMap");
            md.setDisplayName("getStatisticsMap");
            md.setShortDescription("Returns the template name -> template stats map.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getStats 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("fullTemplateName");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the full name of the template with \'.\'s as\n    delimeters."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaServletRequestStats.class.getMethod("getStats", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getStats");
            md.setDisplayName("getStats");
            md.setShortDescription("Returns the template stats for a given template name.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getTemplateStats 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TeaServletRequestStats.class.getMethod("getTemplateStats", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTemplateStats");
            md.setDisplayName("getTemplateStats");
            md.setShortDescription("Returns an array of template stats.\n \n Returns the template raw and aggregate statistics so as to\n better understand the performance of templates through time.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // log 
        //
        paramTypes = new Class[5];
        paramDescriptors = new ParameterDescriptor[5];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("fullTemplateName");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the name of the template"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("startTime");
        pd.setDisplayName("long"); 
        pd.setShortDescription("the time the template was invoked."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("stopTime");
        pd.setDisplayName("long"); 
        pd.setShortDescription("the time the template completed."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("contentLength");
        pd.setDisplayName("long"); 
        pd.setShortDescription("the content length of the result of the template."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.Object[].class; 
        pd = new ParameterDescriptor();
        pd.setName("params");
        pd.setDisplayName("java.lang.Object[]"); 
        pd.setShortDescription("the parameter values the template was invoked with."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaServletRequestStats.class.getMethod("log", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("log");
            md.setDisplayName("log");
            md.setShortDescription("Logs an invokation of an http template invocation.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // reset 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TeaServletRequestStats.class.getMethod("reset", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("reset");
            md.setDisplayName("reset");
            md.setShortDescription("Resets all raw data and aggregate interval statistics.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // reset 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("initialMapSize");
        pd.setDisplayName("int"); 
        pd.setShortDescription("the initial size of the template name / stats map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaServletRequestStats.class.getMethod("reset", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("reset");
            md.setDisplayName("reset");
            md.setShortDescription("Resets all raw data and aggregate interval statistics.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // setAggregateWindowSize 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("aggregateWindowSize");
        pd.setDisplayName("int"); 
        pd.setShortDescription(""); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaServletRequestStats.class.getMethod("setAggregateWindowSize", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("setAggregateWindowSize");
            md.setDisplayName("setAggregateWindowSize");
            md.setShortDescription("Sets the aggregate interval size.\n \n Resets all statistics.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // setRawWindowSize 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("rawWindowSize");
        pd.setDisplayName("int"); 
        pd.setShortDescription(""); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaServletRequestStats.class.getMethod("setRawWindowSize", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("setRawWindowSize");
            md.setDisplayName("setRawWindowSize");
            md.setShortDescription("Sets the raw window size.\n \n Resets all statistics.");   
            
            mds.addElement(md);
        }            
               
                         
        MethodDescriptor[] methodDescriptors = 
                                new MethodDescriptor[mds.size()];
        mds.copyInto(methodDescriptors);
                
        return methodDescriptors;
    }

    // Create the property descriptor objects for the bean.
    private PropertyDescriptor[] createPropertyDescriptors() {
                           
        PropertyDescriptor[] propertyDescriptors = new PropertyDescriptor[4];
        PropertyDescriptor pd = null;
        int propertyIndex = 0;          
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("aggregateWindowSize", TeaServletRequestStats.class, "getAggregateWindowSize", "setAggregateWindowSize");
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("aggregateWindowSize");
            pd.setShortDescription("The aggregate window size.\n \n This defines the number of aggregate intervals that will be\n kept in memory for all templates.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("rawWindowSize", TeaServletRequestStats.class, "getRawWindowSize", "setRawWindowSize");
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("rawWindowSize");
            pd.setShortDescription("The raw window size.\n \n This defines the number of raw data entries that will be\n kept in memory for all templates.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("statisticsMap", TeaServletRequestStats.class, "getStatisticsMap", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("statisticsMap");
            pd.setShortDescription("The template name -> template stats map.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("templateStats", TeaServletRequestStats.class, "getTemplateStats", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("templateStats");
            pd.setShortDescription("An array of template stats.\n \n Returns the template raw and aggregate statistics so as to\n better understand the performance of templates through time.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
        
        if (propertyDescriptors.length == 0) {
            propertyDescriptors = null;    
        }
        
        return propertyDescriptors;
    }

}