/*
 * TemplateStatsBeanInfo.java
 *
 * BeanDoc generated on Fri Mar 16 at 12:39:55 EDT 02012.
 * 
 * See TemplateStats.java for copyright information.
 */

package org.teatrove.teaservlet.stats;

import java.beans.*;
import java.lang.reflect.*;

import java.util.Vector;

/**
 * The BeanInfo class describing TemplateStats. 
 *
 * @author Scott Jappinen
 */
public class TemplateStatsBeanInfo extends SimpleBeanInfo {

    /** BeanDescriptor returned by the <code>getBeanDescriptor</code> 
        method */
    private BeanDescriptor mBeanDescriptor;

    /** BeanInfo array returned by the <code>getAdditionalBeanInfo</code> 
        method */
    private BeanInfo[] mAdditionalBeanInfo;

    /** MethodDescriptor array returned by the 
        <code>getMethodDescriptors</code> method */
    private MethodDescriptor[] mMethodDescriptors;

    /** PropertyDescriptor array returned by the 
        <code>getPropertyDescriptors</code> method */
    private PropertyDescriptor[] mPropertyDescriptors;
    
    /** The index of the default property */
    private int mDefaultPropertyIndex;


    /**
     * Creates a new TemplateStatsBeanInfo.
     */
    public TemplateStatsBeanInfo() {        
                          
        mDefaultPropertyIndex = -1;
        
    }
     
    /**
     * Returns a BeanDescriptor that describes TemplateStats.
     */    
    public BeanDescriptor getBeanDescriptor() {
        
        if (mBeanDescriptor == null) {
            mBeanDescriptor = createBeanDescriptor();       
        }

        return mBeanDescriptor;
    }

    /**
     * Returns a BeanInfo array containing BeanInfo object's for:<br>
     * <code>java.lang.Object</code><br>      
     */  
    public BeanInfo[] getAdditionalBeanInfo() {

        if (mAdditionalBeanInfo == null) {
            mAdditionalBeanInfo = createAdditionalBeanInfo();       
        }

        return mAdditionalBeanInfo;
    }

    /**    
     * Returns MethodDescriptors that describe the methods of 
     * TemplateStats.  Call the 
     * <code>getAdditionalBeanInfo</code> method to get the 
     * method descriptors of the superclass and interfaces.
     */ 
    public MethodDescriptor[] getMethodDescriptors() {

        if (mMethodDescriptors == null) {
            mMethodDescriptors = createMethodDescriptors();       
        }

        return mMethodDescriptors;
    }

    /**    
     * Returns a PropertyDescriptor array that describes the properties of 
     * TemplateStats.
     */ 
    public PropertyDescriptor[] getPropertyDescriptors() {

        if (mPropertyDescriptors == null) {
            mPropertyDescriptors = createPropertyDescriptors();     
        }

        return mPropertyDescriptors;
    }

    /**
     * Return the index of the default property.
     */
    public int getDefaultPropertyIndex() {
        return mDefaultPropertyIndex;
    }


    //
    // Non-public interface
    //

    // Create the bean descriptor for the bean.
    private BeanDescriptor createBeanDescriptor() {                        
        
        BeanDescriptor bd = 
            new BeanDescriptor(TemplateStats.class);
        
        bd.setName("TemplateStats");
        bd.setDisplayName("TemplateStats");
        bd.setShortDescription("This class keeps track of time series performance data for templates.\n \n All data is stored in memory.\n \n There are two different types of data:\n   * raw data\n   * aggregate data\n   \n The RawData keeps track of the most recent start and end times for\n a template invocation in addition to their content lengths. This\n data is kept in a circular queue of a specified rawWindowSize. Once\n the rawWindowSize capacity is reached it creates and AggregateInterval\n which contains a smaller set of descriptive statistics for this template.\n \n In a similar fashion the aggregate intervals are stored in a circular\n queue.\n \n In both cases for raw data and the aggregate intervals when the window\n size is reached the newest data overwrites the oldest data.");        
        bd.setValue("BeanDoc", "4.1.2");
        
        return bd;
    }

    // Create the additional bean info objects for the bean.
    private BeanInfo[] createAdditionalBeanInfo() {
        
        Vector bis = new Vector();
        BeanInfo bi = null;                
        
        bi = null;
        try {
            // Get the BeanInfo for the superclass
            bi = Introspector.getBeanInfo(java.lang.Object.class);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }        
        
        if (bi != null) {    
            bis.addElement(bi);
        }                            
                        
        BeanInfo[] additionalBeanInfo = null;
        if (bis.size() > 0) {
            additionalBeanInfo = new BeanInfo[bis.size()];
            bis.copyInto(additionalBeanInfo);
        }
        
        return additionalBeanInfo;
    }

    // Create the method descriptor objects for the bean.
    private MethodDescriptor[] createMethodDescriptors() {
                
        Class[] paramTypes = null;
        int paramIndex = 0;  
        ParameterDescriptor[] paramDescriptors = null;
        ParameterDescriptor pd = null;
        
        Vector mds = new Vector();
        Method m = null;
        MethodDescriptor md = null;

           
        
        //
        // addMilestone 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.teaservlet.stats.Milestone.class; 
        pd = new ParameterDescriptor();
        pd.setName("milestone");
        pd.setDisplayName("org.teatrove.teaservlet.stats.Milestone"); 
        pd.setShortDescription(""); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("addMilestone", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("addMilestone");
            md.setDisplayName("addMilestone");
            md.setShortDescription("Adds a milestone for this template such as a compile event.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // decrementServicing 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("decrementServicing", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("decrementServicing");
            md.setDisplayName("decrementServicing");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getAggregateIntervalForRawData 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getAggregateIntervalForRawData", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getAggregateIntervalForRawData");
            md.setDisplayName("getAggregateIntervalForRawData");
            md.setShortDescription("Returns an AggregateInterval for the current raw data.\n \n The aggregate interval that is created is not stored and\n is only created for the caller.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getAggregateIntervalForRawData 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("startTime");
        pd.setDisplayName("long"); 
        pd.setShortDescription("the start time to filter on."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("stopTime");
        pd.setDisplayName("long"); 
        pd.setShortDescription("the stop time to filter on."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getAggregateIntervalForRawData", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getAggregateIntervalForRawData");
            md.setDisplayName("getAggregateIntervalForRawData");
            md.setShortDescription("Returns an aggregate interval for the raw data filtered \n by start and stop time.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getAggregateIntervals 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getAggregateIntervals", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getAggregateIntervals");
            md.setDisplayName("getAggregateIntervals");
            md.setShortDescription("Returns a copy of the aggregate intervals in the system\n The number of aggregate intervals will be less than or equal\n to the aggregate interval window size.\n \n The oldest entries are at the beginning and the newest at the end.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getAggregateIntervals 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("startTime");
        pd.setDisplayName("long"); 
        pd.setShortDescription("the start time to filter on."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("stopTime");
        pd.setDisplayName("long"); 
        pd.setShortDescription("the stop time to filter on."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getAggregateIntervals", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getAggregateIntervals");
            md.setDisplayName("getAggregateIntervals");
            md.setShortDescription("Returns the aggregate intervals for the specified startTime and stopTime.\n Any intervals that contain these two endpoints lie between them will be\n included.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getAggregateWindowSize 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getAggregateWindowSize", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getAggregateWindowSize");
            md.setDisplayName("getAggregateWindowSize");
            md.setShortDescription("Returns the number of aggregate windows to keep in memory in a \n circular queue type fashion. Once the aggregate window size is\n reached then new entries overwrite the oldest entries.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getAverageServiceDuration 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getAverageServiceDuration", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getAverageServiceDuration");
            md.setDisplayName("getAverageServiceDuration");
            md.setShortDescription("Returns the overall average performance of this template since \n system start or reset.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getCumulativeServiceTime 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getCumulativeServiceTime", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getCumulativeServiceTime");
            md.setDisplayName("getCumulativeServiceTime");
            md.setShortDescription("Returns the total time in ms. that this template has been service\n since system start or reset.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getFullTemplateName 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getFullTemplateName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getFullTemplateName");
            md.setDisplayName("getFullTemplateName");
            md.setShortDescription("Returns the name of the template these stats are for.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getMilestones 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getMilestones", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getMilestones");
            md.setDisplayName("getMilestones");
            md.setShortDescription("Returns all milestones for this template.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getMilestones 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("startTime");
        pd.setDisplayName("long"); 
        pd.setShortDescription(""); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("stopTime");
        pd.setDisplayName("long"); 
        pd.setShortDescription(""); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getMilestones", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getMilestones");
            md.setDisplayName("getMilestones");
            md.setShortDescription("Returns all milestones for this template between the start and stopTime.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getNumberServicing 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getNumberServicing", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getNumberServicing");
            md.setDisplayName("getNumberServicing");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getPeakServiceDuration 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getPeakServiceDuration", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getPeakServiceDuration");
            md.setDisplayName("getPeakServiceDuration");
            md.setShortDescription("Returns the peak service duration in ms.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getPeakServiceDurationAsDouble 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getPeakServiceDurationAsDouble", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getPeakServiceDurationAsDouble");
            md.setDisplayName("getPeakServiceDurationAsDouble");
            md.setShortDescription("Returns the peak service duration.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getRawContentLengthHistogram 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getRawContentLengthHistogram", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getRawContentLengthHistogram");
            md.setDisplayName("getRawContentLengthHistogram");
            md.setShortDescription("Returns a histogram of the content lengths from the raw data.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getRawContentLengths 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getRawContentLengths", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getRawContentLengths");
            md.setDisplayName("getRawContentLengths");
            md.setShortDescription("Returns the content lengths portion of the raw data as a double array.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getRawData 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getRawData", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getRawData");
            md.setDisplayName("getRawData");
            md.setShortDescription("Returns a copy of the raw data. Some of this data may have\n already been aggregated. The oldest entries are first in the\n array and the newest entries are last.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getRawDurationHistogram 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getRawDurationHistogram", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getRawDurationHistogram");
            md.setDisplayName("getRawDurationHistogram");
            md.setShortDescription("Returns a histogram of the durations from the raw data.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getRawDurations 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getRawDurations", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getRawDurations");
            md.setDisplayName("getRawDurations");
            md.setShortDescription("Returns the duration portion of the raw data as a double array.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getRawDurationsPerContentLength 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getRawDurationsPerContentLength", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getRawDurationsPerContentLength");
            md.setDisplayName("getRawDurationsPerContentLength");
            md.setShortDescription("Returns durations per content length from the raw data as a double array.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getRawDurationsPerContentLengthHistogram 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getRawDurationsPerContentLengthHistogram", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getRawDurationsPerContentLengthHistogram");
            md.setDisplayName("getRawDurationsPerContentLengthHistogram");
            md.setShortDescription("Returns a raw durations per content histogram.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getRawWindowSize 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getRawWindowSize", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getRawWindowSize");
            md.setDisplayName("getRawWindowSize");
            md.setShortDescription("Returns the number of RawData values to keep before aggregating them.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getServicedCount 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getServicedCount", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getServicedCount");
            md.setDisplayName("getServicedCount");
            md.setShortDescription("Returns the total number of times this template has been called\n since reset or startup.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getTemplateName 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getTemplateName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTemplateName");
            md.setDisplayName("getTemplateName");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getTemplatePath 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("getTemplatePath", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTemplatePath");
            md.setDisplayName("getTemplatePath");  
            
            mds.addElement(md);
        }            
           
        
        //
        // incrementServicing 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("incrementServicing", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("incrementServicing");
            md.setDisplayName("incrementServicing");  
            
            mds.addElement(md);
        }            
           
        
        //
        // log 
        //
        paramTypes = new Class[4];
        paramDescriptors = new ParameterDescriptor[4];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("startTime");
        pd.setDisplayName("long"); 
        pd.setShortDescription(""); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("stopTime");
        pd.setDisplayName("long"); 
        pd.setShortDescription(""); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("contentLength");
        pd.setDisplayName("long"); 
        pd.setShortDescription(""); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.Object[].class; 
        pd = new ParameterDescriptor();
        pd.setName("params");
        pd.setDisplayName("java.lang.Object[]"); 
        pd.setShortDescription(""); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("log", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("log");
            md.setDisplayName("log");
            md.setShortDescription("Log a template request.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // reset 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("reset", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("reset");
            md.setDisplayName("reset");  
            
            mds.addElement(md);
        }            
           
        
        //
        // search 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.teaservlet.stats.AggregateInterval[].class; 
        pd = new ParameterDescriptor();
        pd.setName("intervals");
        pd.setDisplayName("org.teatrove.teaservlet.stats.AggregateInterval[]"); 
        pd.setShortDescription("the aggregate intervals to search."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("time");
        pd.setDisplayName("long"); 
        pd.setShortDescription("aggregate intervals will be found for this time."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("search", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("search");
            md.setDisplayName("search");
            md.setShortDescription("This method returns the Aggregate interval containing the specified\n time stamp.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // search 
        //
        paramTypes = new Class[4];
        paramDescriptors = new ParameterDescriptor[4];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.teaservlet.stats.AggregateInterval[].class; 
        pd = new ParameterDescriptor();
        pd.setName("intervals");
        pd.setDisplayName("org.teatrove.teaservlet.stats.AggregateInterval[]"); 
        pd.setShortDescription("Sorted array of AggregateIntervals"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = long.class; 
        pd = new ParameterDescriptor();
        pd.setName("time");
        pd.setDisplayName("long"); 
        pd.setShortDescription("Key to search for"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("begin");
        pd.setDisplayName("int"); 
        pd.setShortDescription("Start posisiton in the index"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("end");
        pd.setDisplayName("int"); 
        pd.setShortDescription("One past the end position in the index"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TemplateStats.class.getMethod("search", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("search");
            md.setDisplayName("search");
            md.setShortDescription("Searches for a AggregateInterval which contains the time passed in.");   
            
            mds.addElement(md);
        }            
               
                         
        MethodDescriptor[] methodDescriptors = 
                                new MethodDescriptor[mds.size()];
        mds.copyInto(methodDescriptors);
                
        return methodDescriptors;
    }

    // Create the property descriptor objects for the bean.
    private PropertyDescriptor[] createPropertyDescriptors() {
                           
        PropertyDescriptor[] propertyDescriptors = new PropertyDescriptor[21];
        PropertyDescriptor pd = null;
        int propertyIndex = 0;          
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("aggregateIntervalForRawData", TemplateStats.class, "getAggregateIntervalForRawData", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("aggregateIntervalForRawData");
            pd.setShortDescription("An AggregateInterval for the current raw data.\n \n The aggregate interval that is created is not stored and\n is only created for the caller.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("aggregateIntervals", TemplateStats.class, "getAggregateIntervals", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("aggregateIntervals");
            pd.setShortDescription("A copy of the aggregate intervals in the system\n The number of aggregate intervals will be less than or equal\n to the aggregate interval window size.\n \n The oldest entries are at the beginning and the newest at the end.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("aggregateWindowSize", TemplateStats.class, "getAggregateWindowSize", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("aggregateWindowSize");
            pd.setShortDescription("The number of aggregate windows to keep in memory in a \n circular queue type fashion. Once the aggregate window size is\n reached then new entries overwrite the oldest entries.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("averageServiceDuration", TemplateStats.class, "getAverageServiceDuration", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("averageServiceDuration");
            pd.setShortDescription("The overall average performance of this template since \n system start or reset.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("cumulativeServiceTime", TemplateStats.class, "getCumulativeServiceTime", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("cumulativeServiceTime");
            pd.setShortDescription("The total time in ms. that this template has been service\n since system start or reset.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("fullTemplateName", TemplateStats.class, "getFullTemplateName", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("fullTemplateName");
            pd.setShortDescription("The name of the template these stats are for.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("milestones", TemplateStats.class, "getMilestones", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("milestones");
            pd.setShortDescription("All milestones for this template.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("numberServicing", TemplateStats.class, "getNumberServicing", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("numberServicing");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("peakServiceDuration", TemplateStats.class, "getPeakServiceDuration", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("peakServiceDuration");
            pd.setShortDescription("The peak service duration in ms.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("peakServiceDurationAsDouble", TemplateStats.class, "getPeakServiceDurationAsDouble", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("peakServiceDurationAsDouble");
            pd.setShortDescription("The peak service duration.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("rawContentLengthHistogram", TemplateStats.class, "getRawContentLengthHistogram", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("rawContentLengthHistogram");
            pd.setShortDescription("A histogram of the content lengths from the raw data.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("rawContentLengths", TemplateStats.class, "getRawContentLengths", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("rawContentLengths");
            pd.setShortDescription("The content lengths portion of the raw data as a double array.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("rawData", TemplateStats.class, "getRawData", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("rawData");
            pd.setShortDescription("A copy of the raw data. Some of this data may have\n already been aggregated. The oldest entries are first in the\n array and the newest entries are last.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("rawDurationHistogram", TemplateStats.class, "getRawDurationHistogram", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("rawDurationHistogram");
            pd.setShortDescription("A histogram of the durations from the raw data.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("rawDurations", TemplateStats.class, "getRawDurations", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("rawDurations");
            pd.setShortDescription("The duration portion of the raw data as a double array.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("rawDurationsPerContentLength", TemplateStats.class, "getRawDurationsPerContentLength", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("rawDurationsPerContentLength");
            pd.setShortDescription("Durations per content length from the raw data as a double array.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("rawDurationsPerContentLengthHistogram", TemplateStats.class, "getRawDurationsPerContentLengthHistogram", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("rawDurationsPerContentLengthHistogram");
            pd.setShortDescription("A raw durations per content histogram.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("rawWindowSize", TemplateStats.class, "getRawWindowSize", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("rawWindowSize");
            pd.setShortDescription("The number of RawData values to keep before aggregating them.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("servicedCount", TemplateStats.class, "getServicedCount", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("servicedCount");
            pd.setShortDescription("The total number of times this template has been called\n since reset or startup.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("templateName", TemplateStats.class, "getTemplateName", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("templateName");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("templatePath", TemplateStats.class, "getTemplatePath", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("templatePath");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
        
        if (propertyDescriptors.length == 0) {
            propertyDescriptors = null;    
        }
        
        return propertyDescriptors;
    }

}