/*
 * ClassDBBeanInfo.java
 *
 * BeanDoc generated on Fri Mar 16 at 12:39:55 EDT 02012.
 * 
 * See ClassDB.java for copyright information.
 */

package org.teatrove.teaservlet.util;

import java.beans.*;
import java.lang.reflect.*;

import java.util.Vector;

/**
 * The BeanInfo class describing ClassDB. 
 *
 * @author BeanDoc
 */
public class ClassDBBeanInfo extends SimpleBeanInfo {

    /** BeanDescriptor returned by the <code>getBeanDescriptor</code> 
        method */
    private BeanDescriptor mBeanDescriptor;

    /** BeanInfo array returned by the <code>getAdditionalBeanInfo</code> 
        method */
    private BeanInfo[] mAdditionalBeanInfo;

    /** MethodDescriptor array returned by the 
        <code>getMethodDescriptors</code> method */
    private MethodDescriptor[] mMethodDescriptors;

    /** PropertyDescriptor array returned by the 
        <code>getPropertyDescriptors</code> method */
    private PropertyDescriptor[] mPropertyDescriptors;
    
    /** The index of the default property */
    private int mDefaultPropertyIndex;


    /**
     * Creates a new ClassDBBeanInfo.
     */
    public ClassDBBeanInfo() {        
                          
        mDefaultPropertyIndex = -1;
        
    }
     
    /**
     * Returns a BeanDescriptor that describes ClassDB.
     */    
    public BeanDescriptor getBeanDescriptor() {
        
        if (mBeanDescriptor == null) {
            mBeanDescriptor = createBeanDescriptor();       
        }

        return mBeanDescriptor;
    }

    /**
     * Returns a BeanInfo array containing BeanInfo object's for:<br>
     * <code>java.lang.Object</code><br>      
     */  
    public BeanInfo[] getAdditionalBeanInfo() {

        if (mAdditionalBeanInfo == null) {
            mAdditionalBeanInfo = createAdditionalBeanInfo();       
        }

        return mAdditionalBeanInfo;
    }

    /**    
     * Returns MethodDescriptors that describe the methods of 
     * ClassDB.  Call the 
     * <code>getAdditionalBeanInfo</code> method to get the 
     * method descriptors of the superclass and interfaces.
     */ 
    public MethodDescriptor[] getMethodDescriptors() {

        if (mMethodDescriptors == null) {
            mMethodDescriptors = createMethodDescriptors();       
        }

        return mMethodDescriptors;
    }

    /**    
     * Returns a PropertyDescriptor array that describes the properties of 
     * ClassDB.
     */ 
    public PropertyDescriptor[] getPropertyDescriptors() {

        if (mPropertyDescriptors == null) {
            mPropertyDescriptors = createPropertyDescriptors();     
        }

        return mPropertyDescriptors;
    }

    /**
     * Return the index of the default property.
     */
    public int getDefaultPropertyIndex() {
        return mDefaultPropertyIndex;
    }


    //
    // Non-public interface
    //

    // Create the bean descriptor for the bean.
    private BeanDescriptor createBeanDescriptor() {                        
        
        BeanDescriptor bd = 
            new BeanDescriptor(ClassDB.class);
        
        bd.setName("ClassDB");
        bd.setDisplayName("ClassDB");
        bd.setShortDescription("");        
        bd.setValue("BeanDoc", "4.1.2");
        
        return bd;
    }

    // Create the additional bean info objects for the bean.
    private BeanInfo[] createAdditionalBeanInfo() {
        
        Vector bis = new Vector();
        BeanInfo bi = null;                
        
        bi = null;
        try {
            // Get the BeanInfo for the superclass
            bi = Introspector.getBeanInfo(java.lang.Object.class);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }        
        
        if (bi != null) {    
            bis.addElement(bi);
        }                            
                        
        BeanInfo[] additionalBeanInfo = null;
        if (bis.size() > 0) {
            additionalBeanInfo = new BeanInfo[bis.size()];
            bis.copyInto(additionalBeanInfo);
        }
        
        return additionalBeanInfo;
    }

    // Create the method descriptor objects for the bean.
    private MethodDescriptor[] createMethodDescriptors() {
                
        Class[] paramTypes = null;
        int paramIndex = 0;  
        ParameterDescriptor[] paramDescriptors = null;
        ParameterDescriptor pd = null;
        
        Vector mds = new Vector();
        Method m = null;
        MethodDescriptor md = null;

           
        
        //
        // addAllowedPackages 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String[].class; 
        pd = new ParameterDescriptor();
        pd.setName("packages");
        pd.setDisplayName("java.lang.String[]"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = ClassDB.class.getMethod("addAllowedPackages", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("addAllowedPackages");
            md.setDisplayName("addAllowedPackages");  
            
            mds.addElement(md);
        }            
           
        
        //
        // addIgnoredPackages 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String[].class; 
        pd = new ParameterDescriptor();
        pd.setName("packages");
        pd.setDisplayName("java.lang.String[]"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = ClassDB.class.getMethod("addIgnoredPackages", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("addIgnoredPackages");
            md.setDisplayName("addIgnoredPackages");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getAllowedPackages 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = ClassDB.class.getMethod("getAllowedPackages", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getAllowedPackages");
            md.setDisplayName("getAllowedPackages");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getAllSubclasses 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("superclass");
        pd.setDisplayName("java.lang.Class"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = ClassDB.class.getMethod("getAllSubclasses", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getAllSubclasses");
            md.setDisplayName("getAllSubclasses");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getAllSubclasses 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("superclass");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = ClassDB.class.getMethod("getAllSubclasses", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getAllSubclasses");
            md.setDisplayName("getAllSubclasses");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getClassIndex 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = ClassDB.class.getMethod("getClassIndex", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getClassIndex");
            md.setDisplayName("getClassIndex");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getIgnoredPackages 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = ClassDB.class.getMethod("getIgnoredPackages", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getIgnoredPackages");
            md.setDisplayName("getIgnoredPackages");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getSubclasses 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("superclass");
        pd.setDisplayName("java.lang.Class"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = ClassDB.class.getMethod("getSubclasses", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getSubclasses");
            md.setDisplayName("getSubclasses");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getSubclasses 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("superclass");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = ClassDB.class.getMethod("getSubclasses", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getSubclasses");
            md.setDisplayName("getSubclasses");  
            
            mds.addElement(md);
        }            
           
        
        //
        // scanAll 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = ClassDB.class.getMethod("scanAll", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("scanAll");
            md.setDisplayName("scanAll");  
            
            mds.addElement(md);
        }            
           
        
        //
        // scanAll 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = javax.servlet.ServletContext.class; 
        pd = new ParameterDescriptor();
        pd.setName("scontext");
        pd.setDisplayName("javax.servlet.ServletContext"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = ClassDB.class.getMethod("scanAll", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("scanAll");
            md.setDisplayName("scanAll");  
            
            mds.addElement(md);
        }            
           
        
        //
        // scanArchives 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.net.URL[].class; 
        pd = new ParameterDescriptor();
        pd.setName("urls");
        pd.setDisplayName("java.net.URL[]"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = ClassDB.class.getMethod("scanArchives", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("scanArchives");
            md.setDisplayName("scanArchives");  
            
            mds.addElement(md);
        }            
           
        
        //
        // setAllowedPackages 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.Set.class; 
        pd = new ParameterDescriptor();
        pd.setName("allowedPackages");
        pd.setDisplayName("java.util.Set"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = ClassDB.class.getMethod("setAllowedPackages", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("setAllowedPackages");
            md.setDisplayName("setAllowedPackages");  
            
            mds.addElement(md);
        }            
           
        
        //
        // setIgnoredPackages 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.Set.class; 
        pd = new ParameterDescriptor();
        pd.setName("ignoredPackages");
        pd.setDisplayName("java.util.Set"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = ClassDB.class.getMethod("setIgnoredPackages", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("setIgnoredPackages");
            md.setDisplayName("setIgnoredPackages");  
            
            mds.addElement(md);
        }            
               
                         
        MethodDescriptor[] methodDescriptors = 
                                new MethodDescriptor[mds.size()];
        mds.copyInto(methodDescriptors);
                
        return methodDescriptors;
    }

    // Create the property descriptor objects for the bean.
    private PropertyDescriptor[] createPropertyDescriptors() {
                           
        PropertyDescriptor[] propertyDescriptors = new PropertyDescriptor[3];
        PropertyDescriptor pd = null;
        int propertyIndex = 0;          
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("allowedPackages", ClassDB.class, "getAllowedPackages", "setAllowedPackages");
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("allowedPackages");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("classIndex", ClassDB.class, "getClassIndex", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("classIndex");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("ignoredPackages", ClassDB.class, "getIgnoredPackages", "setIgnoredPackages");
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("ignoredPackages");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
        
        if (propertyDescriptors.length == 0) {
            propertyDescriptors = null;    
        }
        
        return propertyDescriptors;
    }

}