/*
 * TemplateServerServletBeanInfo.java
 *
 * BeanDoc generated on Fri Mar 16 at 12:39:55 EDT 02012.
 * 
 * See TemplateServerServlet.java for copyright information.
 */

package org.teatrove.teaservlet.util;

import java.beans.*;
import java.lang.reflect.*;

import java.util.Vector;

/**
 * The BeanInfo class describing TemplateServerServlet. 
 *
 * @author Jonathan Colwell
 */
public class TemplateServerServletBeanInfo extends SimpleBeanInfo {

    /** BeanDescriptor returned by the <code>getBeanDescriptor</code> 
        method */
    private BeanDescriptor mBeanDescriptor;

    /** BeanInfo array returned by the <code>getAdditionalBeanInfo</code> 
        method */
    private BeanInfo[] mAdditionalBeanInfo;

    /** MethodDescriptor array returned by the 
        <code>getMethodDescriptors</code> method */
    private MethodDescriptor[] mMethodDescriptors;

    /** PropertyDescriptor array returned by the 
        <code>getPropertyDescriptors</code> method */
    private PropertyDescriptor[] mPropertyDescriptors;
    
    /** The index of the default property */
    private int mDefaultPropertyIndex;


    /**
     * Creates a new TemplateServerServletBeanInfo.
     */
    public TemplateServerServletBeanInfo() {        
                          
        mDefaultPropertyIndex = -1;
        
    }
     
    /**
     * Returns a BeanDescriptor that describes TemplateServerServlet.
     */    
    public BeanDescriptor getBeanDescriptor() {
        
        if (mBeanDescriptor == null) {
            mBeanDescriptor = createBeanDescriptor();       
        }

        return mBeanDescriptor;
    }

    /**
     * Returns a BeanInfo array containing BeanInfo object's for:<br>
     * <code>javax.servlet.http.HttpServlet</code><br>      
     */  
    public BeanInfo[] getAdditionalBeanInfo() {

        if (mAdditionalBeanInfo == null) {
            mAdditionalBeanInfo = createAdditionalBeanInfo();       
        }

        return mAdditionalBeanInfo;
    }

    /**    
     * Returns MethodDescriptors that describe the methods of 
     * TemplateServerServlet.  Call the 
     * <code>getAdditionalBeanInfo</code> method to get the 
     * method descriptors of the superclass and interfaces.
     */ 
    public MethodDescriptor[] getMethodDescriptors() {

        if (mMethodDescriptors == null) {
            mMethodDescriptors = createMethodDescriptors();       
        }

        return mMethodDescriptors;
    }

    /**    
     * Returns a PropertyDescriptor array that describes the properties of 
     * TemplateServerServlet.
     */ 
    public PropertyDescriptor[] getPropertyDescriptors() {

        if (mPropertyDescriptors == null) {
            mPropertyDescriptors = createPropertyDescriptors();     
        }

        return mPropertyDescriptors;
    }

    /**
     * Return the index of the default property.
     */
    public int getDefaultPropertyIndex() {
        return mDefaultPropertyIndex;
    }


    //
    // Non-public interface
    //

    // Create the bean descriptor for the bean.
    private BeanDescriptor createBeanDescriptor() {                        
        
        BeanDescriptor bd = 
            new BeanDescriptor(TemplateServerServlet.class);
        
        bd.setName("TemplateServerServlet");
        bd.setDisplayName("TemplateServerServlet");
        bd.setShortDescription("Used with the RemoteCompiler to allow templates to be loaded over http. \n This servlet should be running on the host specified in the template.path\n parameter of the teaservlet.");        
        bd.setValue("BeanDoc", "4.1.2");
        
        return bd;
    }

    // Create the additional bean info objects for the bean.
    private BeanInfo[] createAdditionalBeanInfo() {
        
        Vector bis = new Vector();
        BeanInfo bi = null;                
        
        bi = null;
        try {
            // Get the BeanInfo for the superclass
            bi = Introspector.getBeanInfo(javax.servlet.http.HttpServlet.class);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }        
        
        if (bi != null) {    
            bis.addElement(bi);
        }                            
                        
        BeanInfo[] additionalBeanInfo = null;
        if (bis.size() > 0) {
            additionalBeanInfo = new BeanInfo[bis.size()];
            bis.copyInto(additionalBeanInfo);
        }
        
        return additionalBeanInfo;
    }

    // Create the method descriptor objects for the bean.
    private MethodDescriptor[] createMethodDescriptors() {
                
        Class[] paramTypes = null;
        int paramIndex = 0;  
        ParameterDescriptor[] paramDescriptors = null;
        ParameterDescriptor pd = null;
        
        Vector mds = new Vector();
        Method m = null;
        MethodDescriptor md = null;

           
        
        //
        // doGet 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = javax.servlet.http.HttpServletRequest.class; 
        pd = new ParameterDescriptor();
        pd.setName("req");
        pd.setDisplayName("javax.servlet.http.HttpServletRequest"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = javax.servlet.http.HttpServletResponse.class; 
        pd = new ParameterDescriptor();
        pd.setName("res");
        pd.setDisplayName("javax.servlet.http.HttpServletResponse"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TemplateServerServlet.class.getMethod("doGet", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("doGet");
            md.setDisplayName("doGet");
            md.setShortDescription("Retrieves all the templates that are newer that the timestamp specified\n by the client.  The pathInfo from the request specifies which templates \n are desired.  QueryString parameters \"timeStamp\" and ??? provide");   
            
            mds.addElement(md);
        }            
           
        
        //
        // doPost 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = javax.servlet.http.HttpServletRequest.class; 
        pd = new ParameterDescriptor();
        pd.setName("req");
        pd.setDisplayName("javax.servlet.http.HttpServletRequest"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = javax.servlet.http.HttpServletResponse.class; 
        pd = new ParameterDescriptor();
        pd.setName("res");
        pd.setDisplayName("javax.servlet.http.HttpServletResponse"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TemplateServerServlet.class.getMethod("doPost", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("doPost");
            md.setDisplayName("doPost");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getTemplateData 
        //
        paramTypes = new Class[3];
        paramDescriptors = new ParameterDescriptor[3];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = javax.servlet.http.HttpServletRequest.class; 
        pd = new ParameterDescriptor();
        pd.setName("req");
        pd.setDisplayName("javax.servlet.http.HttpServletRequest"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = javax.servlet.http.HttpServletResponse.class; 
        pd = new ParameterDescriptor();
        pd.setName("resp");
        pd.setDisplayName("javax.servlet.http.HttpServletResponse"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("path");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TemplateServerServlet.class.getMethod("getTemplateData", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTemplateData");
            md.setDisplayName("getTemplateData");  
            
            mds.addElement(md);
        }            
           
        
        //
        // init 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = javax.servlet.ServletConfig.class; 
        pd = new ParameterDescriptor();
        pd.setName("conf");
        pd.setDisplayName("javax.servlet.ServletConfig"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TemplateServerServlet.class.getMethod("init", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("init");
            md.setDisplayName("init");  
            
            mds.addElement(md);
        }            
           
        
        //
        // listTemplates 
        //
        paramTypes = new Class[3];
        paramDescriptors = new ParameterDescriptor[3];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.io.File.class; 
        pd = new ParameterDescriptor();
        pd.setName("root");
        pd.setDisplayName("java.io.File"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.util.Vector.class; 
        pd = new ParameterDescriptor();
        pd.setName("storage");
        pd.setDisplayName("java.util.Vector"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("path");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TemplateServerServlet.class.getMethod("listTemplates", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("listTemplates");
            md.setDisplayName("listTemplates");  
            
            mds.addElement(md);
        }            
               
                         
        MethodDescriptor[] methodDescriptors = 
                                new MethodDescriptor[mds.size()];
        mds.copyInto(methodDescriptors);
                
        return methodDescriptors;
    }

    // Create the property descriptor objects for the bean.
    private PropertyDescriptor[] createPropertyDescriptors() {
                           
        PropertyDescriptor[] propertyDescriptors = new PropertyDescriptor[0];
        PropertyDescriptor pd = null;
        int propertyIndex = 0;          
        
        if (propertyDescriptors.length == 0) {
            propertyDescriptors = null;    
        }
        
        return propertyDescriptors;
    }

}