/*
 * TeaToolsUtilsBeanInfo.java
 *
 * BeanDoc generated on Fri Mar 16 at 12:39:55 EDT 02012.
 * 
 * See TeaToolsUtils.java for copyright information.
 */

package org.teatrove.teatools;

import java.beans.*;
import java.lang.reflect.*;

import java.util.Vector;

/**
 * The BeanInfo class describing TeaToolsUtils. 
 *
 * @author Mark Masse, Sean Treat
 */
public class TeaToolsUtilsBeanInfo extends SimpleBeanInfo {

    /** BeanDescriptor returned by the <code>getBeanDescriptor</code> 
        method */
    private BeanDescriptor mBeanDescriptor;

    /** BeanInfo array returned by the <code>getAdditionalBeanInfo</code> 
        method */
    private BeanInfo[] mAdditionalBeanInfo;

    /** MethodDescriptor array returned by the 
        <code>getMethodDescriptors</code> method */
    private MethodDescriptor[] mMethodDescriptors;

    /** PropertyDescriptor array returned by the 
        <code>getPropertyDescriptors</code> method */
    private PropertyDescriptor[] mPropertyDescriptors;
    
    /** The index of the default property */
    private int mDefaultPropertyIndex;


    /**
     * Creates a new TeaToolsUtilsBeanInfo.
     */
    public TeaToolsUtilsBeanInfo() {        
                          
        mDefaultPropertyIndex = -1;
        
    }
     
    /**
     * Returns a BeanDescriptor that describes TeaToolsUtils.
     */    
    public BeanDescriptor getBeanDescriptor() {
        
        if (mBeanDescriptor == null) {
            mBeanDescriptor = createBeanDescriptor();       
        }

        return mBeanDescriptor;
    }

    /**
     * Returns a BeanInfo array containing BeanInfo object's for:<br>
     * <code>org.teatrove.tea.runtime.DefaultContext</code><br>
     * <code>org.teatrove.teatools.TeaToolsConstants</code><br>      
     */  
    public BeanInfo[] getAdditionalBeanInfo() {

        if (mAdditionalBeanInfo == null) {
            mAdditionalBeanInfo = createAdditionalBeanInfo();       
        }

        return mAdditionalBeanInfo;
    }

    /**    
     * Returns MethodDescriptors that describe the methods of 
     * TeaToolsUtils.  Call the 
     * <code>getAdditionalBeanInfo</code> method to get the 
     * method descriptors of the superclass and interfaces.
     */ 
    public MethodDescriptor[] getMethodDescriptors() {

        if (mMethodDescriptors == null) {
            mMethodDescriptors = createMethodDescriptors();       
        }

        return mMethodDescriptors;
    }

    /**    
     * Returns a PropertyDescriptor array that describes the properties of 
     * TeaToolsUtils.
     */ 
    public PropertyDescriptor[] getPropertyDescriptors() {

        if (mPropertyDescriptors == null) {
            mPropertyDescriptors = createPropertyDescriptors();     
        }

        return mPropertyDescriptors;
    }

    /**
     * Return the index of the default property.
     */
    public int getDefaultPropertyIndex() {
        return mDefaultPropertyIndex;
    }


    //
    // Non-public interface
    //

    // Create the bean descriptor for the bean.
    private BeanDescriptor createBeanDescriptor() {                        
        
        BeanDescriptor bd = 
            new BeanDescriptor(TeaToolsUtils.class);
        
        bd.setName("TeaToolsUtils");
        bd.setDisplayName("TeaToolsUtils");
        bd.setShortDescription("A Tea Tool\'s best friend.  This class has several useful methods for writing\n tools that work with Tea.  Many of these methods were taken from Kettle \n 3.0.x so that they could be reused in future versions and in other \n applications.\n <p>\n This class was written with the intent that it could be used as a tea\n context class. It provides a collection of functions to make introspection\n possible from Tea.");        
        bd.setValue("BeanDoc", "4.1.2");
        
        return bd;
    }

    // Create the additional bean info objects for the bean.
    private BeanInfo[] createAdditionalBeanInfo() {
        
        Vector bis = new Vector();
        BeanInfo bi = null;                
        
        //
        // Get the BeanInfo for each interface
        //          
        
        bi = null;
        try {
            bi = Introspector.getBeanInfo(org.teatrove.teatools.TeaToolsConstants.class);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }        
        
        if (bi != null) {    
            bis.addElement(bi);
        }            
        
        bi = null;
        try {
            // Get the BeanInfo for the superclass
            bi = Introspector.getBeanInfo(org.teatrove.tea.runtime.DefaultContext.class);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }        
        
        if (bi != null) {    
            bis.addElement(bi);
        }                            
                        
        BeanInfo[] additionalBeanInfo = null;
        if (bis.size() > 0) {
            additionalBeanInfo = new BeanInfo[bis.size()];
            bis.copyInto(additionalBeanInfo);
        }
        
        return additionalBeanInfo;
    }

    // Create the method descriptor objects for the bean.
    private MethodDescriptor[] createMethodDescriptors() {
                
        Class[] paramTypes = null;
        int paramIndex = 0;  
        ParameterDescriptor[] paramDescriptors = null;
        ParameterDescriptor pd = null;
        
        Vector mds = new Vector();
        Method m = null;
        MethodDescriptor md = null;

           
        
        //
        // acceptsSubstitution 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.reflect.Method.class; 
        pd = new ParameterDescriptor();
        pd.setName("m");
        pd.setDisplayName("java.lang.reflect.Method"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("acceptsSubstitution", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("acceptsSubstitution");
            md.setDisplayName("acceptsSubstitution");
            md.setShortDescription("Returns true if the specified method accepts a \n <code>Substitution</code> as its last parameter.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // acceptsSubstitution 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.beans.MethodDescriptor.class; 
        pd = new ParameterDescriptor();
        pd.setName("md");
        pd.setDisplayName("java.beans.MethodDescriptor"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("acceptsSubstitution", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("acceptsSubstitution");
            md.setDisplayName("acceptsSubstitution");
            md.setShortDescription("Returns true if the specified method accepts a \n <code>Substitution</code> as its last parameter.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // compareFileExtension 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("fileName");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("extension");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("compareFileExtension", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("compareFileExtension");
            md.setDisplayName("compareFileExtension");
            md.setShortDescription("Returns true if the specified fileName ends with the specified\n file extension.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // convertArrayClassName 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("className");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the name of the array class"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("bracketIndex");
        pd.setDisplayName("int"); 
        pd.setShortDescription("the index (withing className) of the first \'[\' \n character"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("convertArrayClassName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("convertArrayClassName");
            md.setDisplayName("convertArrayClassName");
            md.setShortDescription("Converts the user-friendly array class name to the VM friendly one.\n For example:\n <UL>\n <LI><code>java.lang.String[]</code> becomes \n <code>[Ljava.lang.String;</code>\n <LI><code>int[][]</code> becomes <code>[[I</code>\n <LI><code>byte[]</code> becomes <code>[B</code>\n </UL>");   
            
            mds.addElement(md);
        }            
           
        
        //
        // createContextClass 
        //
        paramTypes = new Class[3];
        paramDescriptors = new ParameterDescriptor[3];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.ClassLoader.class; 
        pd = new ParameterDescriptor();
        pd.setName("loader");
        pd.setDisplayName("java.lang.ClassLoader"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.Class[].class; 
        pd = new ParameterDescriptor();
        pd.setName("classes");
        pd.setDisplayName("java.lang.Class[]"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String[].class; 
        pd = new ParameterDescriptor();
        pd.setName("prefixNames");
        pd.setDisplayName("java.lang.String[]"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("createContextClass", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("createContextClass");
            md.setDisplayName("createContextClass");
            md.setShortDescription("Merges several classes together, producing a new class that has all \n of the methods of the combined classes.  All methods in the combined \n class delegate to instances of the source classes. If multiple classes\n implement the same method, the first one provided is used. \n The merged class implements all of the interfaces provided by the \n source classes or interfaces.\n <p>\n This method uses org.teatrove.trove.util.MergedClass");   
            
            mds.addElement(md);
        }            
           
        
        //
        // createContextClass 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.ClassLoader.class; 
        pd = new ParameterDescriptor();
        pd.setName("loader");
        pd.setDisplayName("java.lang.ClassLoader"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = org.teatrove.teatools.ContextClassEntry[].class; 
        pd = new ParameterDescriptor();
        pd.setName("contextClasses");
        pd.setDisplayName("org.teatrove.teatools.ContextClassEntry[]"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("createContextClass", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("createContextClass");
            md.setDisplayName("createContextClass");
            md.setShortDescription("Merges several classes together, producing a new class that has all \n of the methods of the combined classes.  All methods in the combined \n class delegate to instances of the source classes. If multiple classes\n implement the same method, the first one provided is used. \n The merged class implements all of the interfaces provided by the \n source classes or interfaces.\n <p>\n This method uses org.teatrove.trove.util.MergedClass");   
            
            mds.addElement(md);
        }            
           
        
        //
        // createMethodDescriptions 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.beans.MethodDescriptor[].class; 
        pd = new ParameterDescriptor();
        pd.setName("mds");
        pd.setDisplayName("java.beans.MethodDescriptor[]"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("createMethodDescriptions", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("createMethodDescriptions");
            md.setDisplayName("createMethodDescriptions");
            md.setShortDescription("Returns an array of MethodDescriptions to wrap and describe the\n specified MethodDescriptors.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // createPackageDescriptor 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("packageName");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("createPackageDescriptor", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("createPackageDescriptor");
            md.setDisplayName("createPackageDescriptor");
            md.setShortDescription("Creates a PackageDescriptor for the named package.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // createPackageDescriptor 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("packageName");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.ClassLoader.class; 
        pd = new ParameterDescriptor();
        pd.setName("classLoader");
        pd.setDisplayName("java.lang.ClassLoader"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("createPackageDescriptor", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("createPackageDescriptor");
            md.setDisplayName("createPackageDescriptor");
            md.setShortDescription("Creates a PackageDescriptor for the named package using the \n specified ClassLoader to load the PackageInfo or Package.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // createParameterDescriptions 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.beans.MethodDescriptor.class; 
        pd = new ParameterDescriptor();
        pd.setName("md");
        pd.setDisplayName("java.beans.MethodDescriptor"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("createParameterDescriptions", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("createParameterDescriptions");
            md.setDisplayName("createParameterDescriptions");
            md.setShortDescription("Returns an array of ParameterDescriptions to wrap and describe the\n parameters of the specified MethodDescriptor.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // createPatternString 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("pattern");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("length");
        pd.setDisplayName("int"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("createPatternString", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("createPatternString");
            md.setDisplayName("createPatternString");
            md.setShortDescription("Creates a String with the specified pattern repeated length\n times.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // createPropertyDescriptions 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.beans.PropertyDescriptor[].class; 
        pd = new ParameterDescriptor();
        pd.setName("pds");
        pd.setDisplayName("java.beans.PropertyDescriptor[]"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("createPropertyDescriptions", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("createPropertyDescriptions");
            md.setDisplayName("createPropertyDescriptions");
            md.setShortDescription("Returns an array of PropertyDescriptions to wrap and describe the\n specified PropertyDescriptors.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // createTypeDescription 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("type");
        pd.setDisplayName("java.lang.Class"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("createTypeDescription", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("createTypeDescription");
            md.setDisplayName("createTypeDescription");
            md.setShortDescription("Returns a TypeDescription object to wrap and describe the\n specified type.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // createWhitespaceString 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("length");
        pd.setDisplayName("int"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("createWhitespaceString", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("createWhitespaceString");
            md.setDisplayName("createWhitespaceString");
            md.setShortDescription("Creates a String of spaces with the specified length.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // decapitalize 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("name");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the string to be decapitalized"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("decapitalize", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("decapitalize");
            md.setDisplayName("decapitalize");
            md.setShortDescription("Converts a string to normal Java variable name capitalization. \n This normally means converting the first character from upper case \n to lower case, but in the (unusual) special case when there is more\n than one character and both the first and second characters are upper\n case, we leave it alone. \n <p>\n Thus \"FooBar\" becomes \"fooBar\" and \"X\" becomes \"x\", but \"URL\" stays \n as \"URL\".");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getArrayClassName 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("clazz");
        pd.setDisplayName("java.lang.Class"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getArrayClassName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getArrayClassName");
            md.setDisplayName("getArrayClassName");
            md.setShortDescription("Formats the class name with trailing square brackets.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getArrayDimensions 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("clazz");
        pd.setDisplayName("java.lang.Class"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getArrayDimensions", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getArrayDimensions");
            md.setDisplayName("getArrayDimensions");
            md.setShortDescription("Returns the array dimensions.  \n Returns 0 if the specified class is not an array.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getArrayDimensionsString 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("clazz");
        pd.setDisplayName("java.lang.Class"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getArrayDimensionsString", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getArrayDimensionsString");
            md.setDisplayName("getArrayDimensionsString");
            md.setShortDescription("Returns the array dimensions String (i.e. \"[][][]\").  \n Returns \"\" (empty string) if the specified class is not an array.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getArrayType 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("clazz");
        pd.setDisplayName("java.lang.Class"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getArrayType", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getArrayType");
            md.setDisplayName("getArrayType");
            md.setShortDescription("Returns the array type.  Returns the specified class if it is not an \n array.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getAttributeValue 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.beans.FeatureDescriptor.class; 
        pd = new ParameterDescriptor();
        pd.setName("feature");
        pd.setDisplayName("java.beans.FeatureDescriptor"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("attributeName");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getAttributeValue", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getAttributeValue");
            md.setDisplayName("getAttributeValue");
            md.setShortDescription("Retrieves the value of the named FeatureDescriptor attribute.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getBeanInfo 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("beanClass");
        pd.setDisplayName("java.lang.Class"); 
        pd.setShortDescription("the bean class to be analyzed"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getBeanInfo", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getBeanInfo");
            md.setDisplayName("getBeanInfo");
            md.setShortDescription("Introspects a Java bean to learn about all its properties, \n exposed methods, and events.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getBeanInfo 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("beanClass");
        pd.setDisplayName("java.lang.Class"); 
        pd.setShortDescription("the bean class to be analyzed"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("stopClass");
        pd.setDisplayName("java.lang.Class"); 
        pd.setShortDescription("the base class at which to stop the analysis. \n Any methods/properties/events in the stopClass or in its baseclasses \n will be ignored in the analysis"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getBeanInfo", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getBeanInfo");
            md.setDisplayName("getBeanInfo");
            md.setShortDescription("Introspects a Java bean to learn all about its properties, exposed \n methods, below a given \"stop\" point.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getClassForName 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("className");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the name of the Class"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getClassForName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getClassForName");
            md.setDisplayName("getClassForName");
            md.setShortDescription("Returns a Class object for a given name. Primitive classes can be \n loaded via thier normal names (i.e. \"float\"). Array classes can be\n loaded using either the normal Java name (i.e. int[][]) or the VM\n name (i.e. [[I).  \n <p>\n Note this method swallows all exceptions and simply returns null if \n the class could not be loaded.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getClassForName 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("className");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the name of the Class"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.ClassLoader.class; 
        pd = new ParameterDescriptor();
        pd.setName("classLoader");
        pd.setDisplayName("java.lang.ClassLoader"); 
        pd.setShortDescription("the ClassLoader to use"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getClassForName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getClassForName");
            md.setDisplayName("getClassForName");
            md.setShortDescription("Returns a Class object for a given name. Primitive classes can be \n loaded via thier normal names (i.e. \"float\"). Array classes can be\n loaded using either the normal Java name (i.e. int[][]) or the VM\n name (i.e. [[I).  \n <p>\n Note this method swallows all exceptions and simply returns null if \n the class could not be loaded.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getClassName 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("clazz");
        pd.setDisplayName("java.lang.Class"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getClassName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getClassName");
            md.setDisplayName("getClassName");
            md.setShortDescription("Returns the class name of the specified class.  The class name returned\n does not include the package. This method provides special formatting \n for array and inner classes.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getClassName 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("fullClassName");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getClassName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getClassName");
            md.setDisplayName("getClassName");
            md.setShortDescription("Returns the class name of the specified class.  The class name returned\n does not include the package. This method provides special formatting \n for inner classes.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getClassPackage 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("clazz");
        pd.setDisplayName("java.lang.Class"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getClassPackage", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getClassPackage");
            md.setDisplayName("getClassPackage");
            md.setShortDescription("Returns the package name of the specified class.  Returns \"\" if the\n class has no package.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getClassPackage 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("fullClassName");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getClassPackage", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getClassPackage");
            md.setDisplayName("getClassPackage");
            md.setShortDescription("Returns the package name of the specified class.  Returns null if the\n class has no package.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getClassTypeName 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("clazz");
        pd.setDisplayName("java.lang.Class"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getClassTypeName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getClassTypeName");
            md.setDisplayName("getClassTypeName");
            md.setShortDescription("Returns the type of the specified class.\n <p>\n <UL>\n <LI>A Class returns \"class\"\n <LI>An Interface returns \"interface\"\n <LI>An array returns null\n <LI>A primitive returns null\n </UL>");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getDescription 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.beans.FeatureDescriptor.class; 
        pd = new ParameterDescriptor();
        pd.setName("feature");
        pd.setDisplayName("java.beans.FeatureDescriptor"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getDescription", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getDescription");
            md.setDisplayName("getDescription");
            md.setShortDescription("Returns the FeatureDescriptor\'s shortDescription or \"\" if the\n shortDescription is the same as the displayName.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getDescriptionFirstSentence 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.beans.FeatureDescriptor.class; 
        pd = new ParameterDescriptor();
        pd.setName("feature");
        pd.setDisplayName("java.beans.FeatureDescriptor"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getDescriptionFirstSentence", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getDescriptionFirstSentence");
            md.setDisplayName("getDescriptionFirstSentence");
            md.setShortDescription("Returns the first sentence of the FeatureDescriptor\'s \n shortDescription.  Returns \"\" if the shortDescription is the same as\n the displayName (the default for reflection-generated \n FeatureDescriptors).");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getFirstSentence 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("paragraph");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getFirstSentence", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getFirstSentence");
            md.setDisplayName("getFirstSentence");
            md.setShortDescription("Returns the first sentence of the specified paragraph.  Uses\n <code>java.text.BreakIterator.getSentenceInstance()</code>");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getFullClassName 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("clazz");
        pd.setDisplayName("java.lang.Class"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getFullClassName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getFullClassName");
            md.setDisplayName("getFullClassName");
            md.setShortDescription("Returns the full class name of the specified class.  This method \n provides special formatting for array and inner classes.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getFullClassName 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("fullClassName");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getFullClassName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getFullClassName");
            md.setDisplayName("getFullClassName");
            md.setShortDescription("Returns the full class name of the specified class.  This method \n provides special formatting for inner classes.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getInnerClassName 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("className");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getInnerClassName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getInnerClassName");
            md.setDisplayName("getInnerClassName");
            md.setShortDescription("Returns the className with \'$\'s changed to \'.\'s");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getModifiers 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("modifier");
        pd.setDisplayName("int"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getModifiers", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getModifiers");
            md.setDisplayName("getModifiers");
            md.setShortDescription("Returns a Modifiers instance that can be used to check the modifier\n int returned by the Class.getModifiers or Member.getModifiers\n method.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getPackageVersion 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("packageName");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getPackageVersion", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getPackageVersion");
            md.setDisplayName("getPackageVersion");
            md.setShortDescription("Create a version information string based on what the build process\n provided.  The string is of the form \"M.m.r\" or \n \"M.m.r.bbbb\" (i.e. 1.1.0.0004) if the build number can be retrieved.\n Returns <code>null</code> if the version string cannot be retrieved.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getTeaBeanPropertyDescriptors 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("beanClass");
        pd.setDisplayName("java.lang.Class"); 
        pd.setShortDescription("the bean class to introspect"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getTeaBeanPropertyDescriptors", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTeaBeanPropertyDescriptors");
            md.setDisplayName("getTeaBeanPropertyDescriptors");
            md.setShortDescription("A function that returns an array of all the available properties on\n a given class.\n <p>\n <b>NOTE:</b> If possible, the results of this method should be cached\n by the caller.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getTeaContextMethodDescriptors 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("contextClass");
        pd.setDisplayName("java.lang.Class"); 
        pd.setShortDescription("the Tea context Class to introspect (any class will\n work fine)"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getTeaContextMethodDescriptors", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTeaContextMethodDescriptors");
            md.setDisplayName("getTeaContextMethodDescriptors");
            md.setShortDescription("Gets the MethodDescriptors of the specified context class including\n all of the MethodDescriptors for methods declared in the class\'s \n superclass and interfaces");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getTeaContextMethodDescriptors 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class[].class; 
        pd = new ParameterDescriptor();
        pd.setName("contextClasses");
        pd.setDisplayName("java.lang.Class[]"); 
        pd.setShortDescription("the Tea context classes to introspect"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getTeaContextMethodDescriptors", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTeaContextMethodDescriptors");
            md.setDisplayName("getTeaContextMethodDescriptors");
            md.setShortDescription("Gets the complete, combined set of MethodDescriptors for the specified\n context classes.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getTeaContextMethodDescriptors 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("contextClass");
        pd.setDisplayName("java.lang.Class"); 
        pd.setShortDescription("the Tea context Class to introspect (any class will\n work fine)"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = boolean.class; 
        pd = new ParameterDescriptor();
        pd.setName("specifiedClassOnly");
        pd.setDisplayName("boolean"); 
        pd.setShortDescription("true indicates that this function should \n only return MethodDescriptors declared by the specified Class."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getTeaContextMethodDescriptors", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTeaContextMethodDescriptors");
            md.setDisplayName("getTeaContextMethodDescriptors");
            md.setShortDescription("Gets the MethodDescriptors of the specified context class");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getTeaFullClassName 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("clazz");
        pd.setDisplayName("java.lang.Class"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("getTeaFullClassName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTeaFullClassName");
            md.setDisplayName("getTeaFullClassName");
            md.setShortDescription("Returns the full class name of the specified class.  This method \n provides special formatting for array and inner classes.  If the \n specified class is implicitly imported by Tea, then its package is\n omitted in the returned name.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // isForeachCompatible 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("clazz");
        pd.setDisplayName("java.lang.Class"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("isForeachCompatible", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("isForeachCompatible");
            md.setDisplayName("isForeachCompatible");
            md.setShortDescription("Returns true if the specifed class is compatible with Tea\'s \n <code>foreach</code> statement.  Compatibility implies that the\n class can be iterated on by the <code>foreach</code>.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // isIfCompatible 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("clazz");
        pd.setDisplayName("java.lang.Class"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("isIfCompatible", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("isIfCompatible");
            md.setDisplayName("isIfCompatible");
            md.setShortDescription("Returns true if the specifed class is compatible with Tea\'s <code>if\n </code> statement.  Only Boolean.class and boolean.class qualify.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // isImplicitTeaImport 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("clazz");
        pd.setDisplayName("java.lang.Class"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("isImplicitTeaImport", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("isImplicitTeaImport");
            md.setDisplayName("isImplicitTeaImport");
            md.setShortDescription("Returns true if the specified class is \n implicitly imported by Tea.\n <p>\n Returns true if the specified class represents a primitive type or\n a class or interface defined in one of the IMPLICIT_TEA_IMPORTS \n packages.  This method also works for array types.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // isImplicitTeaImport 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("classOrPackageName");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("isImplicitTeaImport", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("isImplicitTeaImport");
            md.setDisplayName("isImplicitTeaImport");
            md.setShortDescription("Returns true if the specified class or package is\n implicitly imported by Tea.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // isLikelyContextClass 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("clazz");
        pd.setDisplayName("java.lang.Class"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("isLikelyContextClass", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("isLikelyContextClass");
            md.setDisplayName("isLikelyContextClass");
            md.setShortDescription("Returns true if it is likely that the specified class serves as \n a Tea runtime context class.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // isTeaFileName 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("fileName");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("isTeaFileName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("isTeaFileName");
            md.setDisplayName("isTeaFileName");
            md.setShortDescription("Returns true if the specifed fileName is a Tea file.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // loadContextClasses 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.ClassLoader.class; 
        pd = new ParameterDescriptor();
        pd.setName("loader");
        pd.setDisplayName("java.lang.ClassLoader"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = org.teatrove.teatools.ContextClassEntry[].class; 
        pd = new ParameterDescriptor();
        pd.setName("contextClasses");
        pd.setDisplayName("org.teatrove.teatools.ContextClassEntry[]"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("loadContextClasses", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("loadContextClasses");
            md.setDisplayName("loadContextClasses");
            md.setShortDescription("Loads and returns the runtime context classes specified by the \n ContextClassEntry array.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // main 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String[].class; 
        pd = new ParameterDescriptor();
        pd.setName("args");
        pd.setDisplayName("java.lang.String[]"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("main", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("main");
            md.setDisplayName("main");
            md.setShortDescription("Test program");   
            
            mds.addElement(md);
        }            
           
        
        //
        // parseClassName 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("fullClassName");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("parseClassName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("parseClassName");
            md.setDisplayName("parseClassName");
            md.setShortDescription("Splits a class name into two strings.  \n <br>\n [0] = package name (or null if the class is unpackaged) <br>\n [1] = class name");   
            
            mds.addElement(md);
        }            
           
        
        //
        // print 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Object.class; 
        pd = new ParameterDescriptor();
        pd.setName("obj");
        pd.setDisplayName("java.lang.Object"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("print", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("print");
            md.setDisplayName("print");  
            
            mds.addElement(md);
        }            
           
        
        //
        // removeFileExtension 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("fileName");
        pd.setDisplayName("java.lang.String"); 
        pd.setShortDescription("the String with an (optional) extension"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("removeFileExtension", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("removeFileExtension");
            md.setDisplayName("removeFileExtension");
            md.setShortDescription("Removes the file extension (all text after the last \'.\' character)\n from the specified fileName.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // sortDescriptors 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.beans.FeatureDescriptor[].class; 
        pd = new ParameterDescriptor();
        pd.setName("fds");
        pd.setDisplayName("java.beans.FeatureDescriptor[]"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("sortDescriptors", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("sortDescriptors");
            md.setDisplayName("sortDescriptors");
            md.setShortDescription("Sorts an array of FeatureDescriptors based on the method name and \n if these descriptors are MethodDescriptors, by param count as well.\n To prevent damage to the original array, a clone is made, sorted,\n and returned from this method.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // sortMethodDescriptors 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.beans.MethodDescriptor[].class; 
        pd = new ParameterDescriptor();
        pd.setName("mds");
        pd.setDisplayName("java.beans.MethodDescriptor[]"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("sortMethodDescriptors", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("sortMethodDescriptors");
            md.setDisplayName("sortMethodDescriptors");
            md.setShortDescription("Sorts an array of MethodDescriptors based on the method name and \n param count.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // sortPropertyDescriptors 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.beans.PropertyDescriptor[].class; 
        pd = new ParameterDescriptor();
        pd.setName("pds");
        pd.setDisplayName("java.beans.PropertyDescriptor[]"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TeaToolsUtils.class.getMethod("sortPropertyDescriptors", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("sortPropertyDescriptors");
            md.setDisplayName("sortPropertyDescriptors");
            md.setShortDescription("Sorts an array of PropertyDescriptors based on name.");   
            
            mds.addElement(md);
        }            
               
                         
        MethodDescriptor[] methodDescriptors = 
                                new MethodDescriptor[mds.size()];
        mds.copyInto(methodDescriptors);
                
        return methodDescriptors;
    }

    // Create the property descriptor objects for the bean.
    private PropertyDescriptor[] createPropertyDescriptors() {
                           
        PropertyDescriptor[] propertyDescriptors = new PropertyDescriptor[0];
        PropertyDescriptor pd = null;
        int propertyIndex = 0;          
        
        if (propertyDescriptors.length == 0) {
            propertyDescriptors = null;    
        }
        
        return propertyDescriptors;
    }

}