/*
 * TypeDescriptionBeanInfo.java
 *
 * BeanDoc generated on Fri Mar 16 at 12:39:55 EDT 02012.
 * 
 * See TypeDescription.java for copyright information.
 */

package org.teatrove.teatools;

import java.beans.*;
import java.lang.reflect.*;

import java.util.Vector;

/**
 * The BeanInfo class describing TypeDescription. 
 *
 * @author Mark Masse
 */
public class TypeDescriptionBeanInfo extends SimpleBeanInfo {

    /** BeanDescriptor returned by the <code>getBeanDescriptor</code> 
        method */
    private BeanDescriptor mBeanDescriptor;

    /** BeanInfo array returned by the <code>getAdditionalBeanInfo</code> 
        method */
    private BeanInfo[] mAdditionalBeanInfo;

    /** MethodDescriptor array returned by the 
        <code>getMethodDescriptors</code> method */
    private MethodDescriptor[] mMethodDescriptors;

    /** PropertyDescriptor array returned by the 
        <code>getPropertyDescriptors</code> method */
    private PropertyDescriptor[] mPropertyDescriptors;
    
    /** The index of the default property */
    private int mDefaultPropertyIndex;


    /**
     * Creates a new TypeDescriptionBeanInfo.
     */
    public TypeDescriptionBeanInfo() {        
                          
        mDefaultPropertyIndex = -1;
        
    }
     
    /**
     * Returns a BeanDescriptor that describes TypeDescription.
     */    
    public BeanDescriptor getBeanDescriptor() {
        
        if (mBeanDescriptor == null) {
            mBeanDescriptor = createBeanDescriptor();       
        }

        return mBeanDescriptor;
    }

    /**
     * Returns a BeanInfo array containing BeanInfo object's for:<br>
     * <code>org.teatrove.teatools.FeatureDescription</code><br>      
     */  
    public BeanInfo[] getAdditionalBeanInfo() {

        if (mAdditionalBeanInfo == null) {
            mAdditionalBeanInfo = createAdditionalBeanInfo();       
        }

        return mAdditionalBeanInfo;
    }

    /**    
     * Returns MethodDescriptors that describe the methods of 
     * TypeDescription.  Call the 
     * <code>getAdditionalBeanInfo</code> method to get the 
     * method descriptors of the superclass and interfaces.
     */ 
    public MethodDescriptor[] getMethodDescriptors() {

        if (mMethodDescriptors == null) {
            mMethodDescriptors = createMethodDescriptors();       
        }

        return mMethodDescriptors;
    }

    /**    
     * Returns a PropertyDescriptor array that describes the properties of 
     * TypeDescription.
     */ 
    public PropertyDescriptor[] getPropertyDescriptors() {

        if (mPropertyDescriptors == null) {
            mPropertyDescriptors = createPropertyDescriptors();     
        }

        return mPropertyDescriptors;
    }

    /**
     * Return the index of the default property.
     */
    public int getDefaultPropertyIndex() {
        return mDefaultPropertyIndex;
    }


    //
    // Non-public interface
    //

    // Create the bean descriptor for the bean.
    private BeanDescriptor createBeanDescriptor() {                        
        
        BeanDescriptor bd = 
            new BeanDescriptor(TypeDescription.class);
        
        bd.setName("TypeDescription");
        bd.setDisplayName("TypeDescription");
        bd.setShortDescription("Object wrapper for TeaToolsUtils functions that operate on Class objects.\n This class offers an O-O interface alternative to the TeaToolsUtils \n procedural design.");        
        bd.setValue("BeanDoc", "4.1.2");
        
        return bd;
    }

    // Create the additional bean info objects for the bean.
    private BeanInfo[] createAdditionalBeanInfo() {
        
        Vector bis = new Vector();
        BeanInfo bi = null;                
        
        bi = null;
        try {
            // Get the BeanInfo for the superclass
            bi = Introspector.getBeanInfo(org.teatrove.teatools.FeatureDescription.class);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }        
        
        if (bi != null) {    
            bis.addElement(bi);
        }                            
                        
        BeanInfo[] additionalBeanInfo = null;
        if (bis.size() > 0) {
            additionalBeanInfo = new BeanInfo[bis.size()];
            bis.copyInto(additionalBeanInfo);
        }
        
        return additionalBeanInfo;
    }

    // Create the method descriptor objects for the bean.
    private MethodDescriptor[] createMethodDescriptors() {
                
        Class[] paramTypes = null;
        int paramIndex = 0;  
        ParameterDescriptor[] paramDescriptors = null;
        ParameterDescriptor pd = null;
        
        Vector mds = new Vector();
        Method m = null;
        MethodDescriptor md = null;

           
        
        //
        // getArrayDimensions 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getArrayDimensions", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getArrayDimensions");
            md.setDisplayName("getArrayDimensions");
            md.setShortDescription("Returns the array dimensions.  \n Returns 0 if the type is not an array.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getArrayDimensionsString 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getArrayDimensionsString", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getArrayDimensionsString");
            md.setDisplayName("getArrayDimensionsString");
            md.setShortDescription("Returns the array dimensions String (i.e. \"[][][]\").  \n Returns \"\" (empty string) if the type is not an array.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getArrayType 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getArrayType", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getArrayType");
            md.setDisplayName("getArrayType");
            md.setShortDescription("Returns the array type.  Returns this if it is not an \n array type.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getBeanInfo 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getBeanInfo", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getBeanInfo");
            md.setDisplayName("getBeanInfo");
            md.setShortDescription("Introspects a Java bean to learn about all its properties, \n exposed methods, and events.  Returns null if the BeanInfo \n could not be created.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getBeanInfo 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.Class.class; 
        pd = new ParameterDescriptor();
        pd.setName("stopClass");
        pd.setDisplayName("java.lang.Class"); 
        pd.setShortDescription("the base class at which to stop the analysis. \n Any methods/properties/events in the stopClass or in its baseclasses \n will be ignored in the analysis"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getBeanInfo", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getBeanInfo");
            md.setDisplayName("getBeanInfo");
            md.setShortDescription("Introspects a Java bean to learn all about its properties, exposed \n methods, below a given \"stop\" point.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getFeatureDescriptor 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getFeatureDescriptor", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getFeatureDescriptor");
            md.setDisplayName("getFeatureDescriptor");
            md.setShortDescription("Returns the FeatureDescriptor that is wrapped by this \n FeatureDescription");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getFullName 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getFullName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getFullName");
            md.setDisplayName("getFullName");
            md.setShortDescription("Returns the full name of the type.  This method \n provides special formatting for array and inner classes.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getLongFormat 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getLongFormat", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getLongFormat");
            md.setDisplayName("getLongFormat");
            md.setShortDescription("Returns a long format String for this FeatureDescription");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getMethodDescriptions 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getMethodDescriptions", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getMethodDescriptions");
            md.setDisplayName("getMethodDescriptions");
            md.setShortDescription("Returns the type\'s MethodDescriptions.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getMethodDescriptors 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getMethodDescriptors", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getMethodDescriptors");
            md.setDisplayName("getMethodDescriptors");
            md.setShortDescription("Returns the type\'s MethodDescriptors.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getModifiers 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getModifiers", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getModifiers");
            md.setDisplayName("getModifiers");
            md.setShortDescription("Returns a Modifiers instance that can be used to check the type\'s\n modifiers.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getName 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getName");
            md.setDisplayName("getName");
            md.setShortDescription("Returns the class name of the type.  The class name returned\n does not include the package. This method provides special formatting \n for array and inner classes.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getPackage 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getPackage", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getPackage");
            md.setDisplayName("getPackage");
            md.setShortDescription("Returns the package name of the class.  Returns \"\" if the\n class has no package.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getPropertyDescriptions 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getPropertyDescriptions", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getPropertyDescriptions");
            md.setDisplayName("getPropertyDescriptions");
            md.setShortDescription("Returns the type\'s PropertyDescriptions.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getPropertyDescriptors 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getPropertyDescriptors", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getPropertyDescriptors");
            md.setDisplayName("getPropertyDescriptors");
            md.setShortDescription("Returns the type\'s PropertyDescriptors.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getShortFormat 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getShortFormat", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getShortFormat");
            md.setDisplayName("getShortFormat");
            md.setShortDescription("Returns a short format String for this FeatureDescription");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getTeaBeanPropertyDescriptions 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getTeaBeanPropertyDescriptions", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTeaBeanPropertyDescriptions");
            md.setDisplayName("getTeaBeanPropertyDescriptions");
            md.setShortDescription("Returns an array of all the available properties on the class.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getTeaBeanPropertyDescriptors 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getTeaBeanPropertyDescriptors", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTeaBeanPropertyDescriptors");
            md.setDisplayName("getTeaBeanPropertyDescriptors");
            md.setShortDescription("Returns an array of all the available properties on the class.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getTeaContextMethodDescriptions 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getTeaContextMethodDescriptions", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTeaContextMethodDescriptions");
            md.setDisplayName("getTeaContextMethodDescriptions");
            md.setShortDescription("Gets the MethodDescriptions of the context class including\n all of the MethodDescriptions for methods declared in the class\'s \n superclass and interfaces");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getTeaContextMethodDescriptors 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getTeaContextMethodDescriptors", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTeaContextMethodDescriptors");
            md.setDisplayName("getTeaContextMethodDescriptors");
            md.setShortDescription("Gets the MethodDescriptors of the context class including\n all of the MethodDescriptors for methods declared in the class\'s \n superclass and interfaces");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getTeaContextMethodDescriptors 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = boolean.class; 
        pd = new ParameterDescriptor();
        pd.setName("thisClassOnly");
        pd.setDisplayName("boolean"); 
        pd.setShortDescription("true indicates that this function should \n only return MethodDescriptors declared by the wrapped Class."); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getTeaContextMethodDescriptors", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTeaContextMethodDescriptors");
            md.setDisplayName("getTeaContextMethodDescriptors");
            md.setShortDescription("Gets the MethodDescriptors of the context class");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getTeaFullName 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getTeaFullName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTeaFullName");
            md.setDisplayName("getTeaFullName");
            md.setShortDescription("Returns the full class name of the class.  This method \n provides special formatting for array and inner classes.  If the \n specified class is implicitly imported by Tea, then its package is\n omitted in the returned name.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getType 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getType", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getType");
            md.setDisplayName("getType");
            md.setShortDescription("Returns the type.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getTypeName 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getTypeName", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getTypeName");
            md.setDisplayName("getTypeName");
            md.setShortDescription("Returns the name of the type of the Class described by this \n TypeDescription.\n <p>\n <UL>\n <LI>A Class returns \"class\"\n <LI>An Interface returns \"interface\"\n <LI>An array returns null\n <LI>A primitive returns null\n </UL>");   
            
            mds.addElement(md);
        }            
           
        
        //
        // getVersion 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("getVersion", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getVersion");
            md.setDisplayName("getVersion");
            md.setShortDescription("Create a version information string based on what the build process\n provided.  The string is of the form \"M.m.r\" or \n \"M.m.r.bbbb\" (i.e. 1.1.0.0004) if the build number can be retrieved.\n Returns <code>null</code> if the version string cannot be retrieved.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // isForeachCompatible 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("isForeachCompatible", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("isForeachCompatible");
            md.setDisplayName("isForeachCompatible");
            md.setShortDescription("Returns true if the class is compatible with Tea\'s \n <code>foreach</code> statement.  Compatibility implies that the\n class can be iterated on by the <code>foreach</code>.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // isIfCompatible 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("isIfCompatible", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("isIfCompatible");
            md.setDisplayName("isIfCompatible");
            md.setShortDescription("Returns true if the class is compatible with Tea\'s <code>if\n </code> statement.  Only Boolean.class and boolean.class qualify.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // isImplicitTeaImport 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("isImplicitTeaImport", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("isImplicitTeaImport");
            md.setDisplayName("isImplicitTeaImport");
            md.setShortDescription("Returns true if the class is \n implicitly imported by Tea.\n <p>\n Returns true if the specified class represents a primitive type or\n a class or interface defined in one of the IMPLICIT_TEA_IMPORTS \n packages.  This method also works for array types.");   
            
            mds.addElement(md);
        }            
           
        
        //
        // isLikelyContextClass 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = TypeDescription.class.getMethod("isLikelyContextClass", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("isLikelyContextClass");
            md.setDisplayName("isLikelyContextClass");
            md.setShortDescription("Returns true if it is likely that the class serves as \n a Tea runtime context class.");   
            
            mds.addElement(md);
        }            
               
                         
        MethodDescriptor[] methodDescriptors = 
                                new MethodDescriptor[mds.size()];
        mds.copyInto(methodDescriptors);
                
        return methodDescriptors;
    }

    // Create the property descriptor objects for the bean.
    private PropertyDescriptor[] createPropertyDescriptors() {
                           
        PropertyDescriptor[] propertyDescriptors = new PropertyDescriptor[27];
        PropertyDescriptor pd = null;
        int propertyIndex = 0;          
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("arrayDimensions", TypeDescription.class, "getArrayDimensions", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("arrayDimensions");
            pd.setShortDescription("The array dimensions.  \n Returns 0 if the type is not an array.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("arrayDimensionsString", TypeDescription.class, "getArrayDimensionsString", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("arrayDimensionsString");
            pd.setShortDescription("The array dimensions String (i.e. \"[][][]\").  \n Returns \"\" (empty string) if the type is not an array.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("arrayType", TypeDescription.class, "getArrayType", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("arrayType");
            pd.setShortDescription("The array type.  Returns this if it is not an \n array type.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("beanInfo", TypeDescription.class, "getBeanInfo", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("beanInfo");
            pd.setShortDescription("Introspects a Java bean to learn about all its properties, \n exposed methods, and events.  Returns null if the BeanInfo \n could not be created.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("featureDescriptor", TypeDescription.class, "getFeatureDescriptor", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("featureDescriptor");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("fullName", TypeDescription.class, "getFullName", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("fullName");
            pd.setShortDescription("The full name of the type.  This method \n provides special formatting for array and inner classes.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("longFormat", TypeDescription.class, "getLongFormat", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("longFormat");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("methodDescriptions", TypeDescription.class, "getMethodDescriptions", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("methodDescriptions");
            pd.setShortDescription("The type\'s MethodDescriptions.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("methodDescriptors", TypeDescription.class, "getMethodDescriptors", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("methodDescriptors");
            pd.setShortDescription("The type\'s MethodDescriptors.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("modifiers", TypeDescription.class, "getModifiers", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("modifiers");
            pd.setShortDescription("A Modifiers instance that can be used to check the type\'s\n modifiers.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("name", TypeDescription.class, "getName", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("name");
            pd.setShortDescription("The class name of the type.  The class name returned\n does not include the package. This method provides special formatting \n for array and inner classes.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("package", TypeDescription.class, "getPackage", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("package");
            pd.setShortDescription("The package name of the class.  Returns \"\" if the\n class has no package.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("propertyDescriptions", TypeDescription.class, "getPropertyDescriptions", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("propertyDescriptions");
            pd.setShortDescription("The type\'s PropertyDescriptions.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("propertyDescriptors", TypeDescription.class, "getPropertyDescriptors", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("propertyDescriptors");
            pd.setShortDescription("The type\'s PropertyDescriptors.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("shortFormat", TypeDescription.class, "getShortFormat", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("shortFormat");
            pd.setShortDescription("");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("teaBeanPropertyDescriptions", TypeDescription.class, "getTeaBeanPropertyDescriptions", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("teaBeanPropertyDescriptions");
            pd.setShortDescription("An array of all the available properties on the class.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("teaBeanPropertyDescriptors", TypeDescription.class, "getTeaBeanPropertyDescriptors", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("teaBeanPropertyDescriptors");
            pd.setShortDescription("An array of all the available properties on the class.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("teaContextMethodDescriptions", TypeDescription.class, "getTeaContextMethodDescriptions", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("teaContextMethodDescriptions");
            pd.setShortDescription("The MethodDescriptions of the context class including\n all of the MethodDescriptions for methods declared in the class\'s \n superclass and interfaces");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("teaContextMethodDescriptors", TypeDescription.class, "getTeaContextMethodDescriptors", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("teaContextMethodDescriptors");
            pd.setShortDescription("The MethodDescriptors of the context class including\n all of the MethodDescriptors for methods declared in the class\'s \n superclass and interfaces");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("teaFullName", TypeDescription.class, "getTeaFullName", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("teaFullName");
            pd.setShortDescription("The full class name of the class.  This method \n provides special formatting for array and inner classes.  If the \n specified class is implicitly imported by Tea, then its package is\n omitted in the returned name.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("type", TypeDescription.class, "getType", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("type");
            pd.setShortDescription("The type.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("typeName", TypeDescription.class, "getTypeName", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("typeName");
            pd.setShortDescription("The name of the type of the Class described by this \n TypeDescription.\n <p>\n <UL>\n <LI>A Class returns \"class\"\n <LI>An Interface returns \"interface\"\n <LI>An array returns null\n <LI>A primitive returns null\n </UL>");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("version", TypeDescription.class, "getVersion", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("version");
            pd.setShortDescription("Create a version information string based on what the build process\n provided.  The string is of the form \"M.m.r\" or \n \"M.m.r.bbbb\" (i.e. 1.1.0.0004) if the build number can be retrieved.\n Returns <code>null</code> if the version string cannot be retrieved.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("foreachCompatible", TypeDescription.class, "isForeachCompatible", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("foreachCompatible");
            pd.setShortDescription("True if the class is compatible with Tea\'s \n <code>foreach</code> statement.  Compatibility implies that the\n class can be iterated on by the <code>foreach</code>.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("ifCompatible", TypeDescription.class, "isIfCompatible", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("ifCompatible");
            pd.setShortDescription("True if the class is compatible with Tea\'s <code>if\n </code> statement.  Only Boolean.class and boolean.class qualify.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("implicitTeaImport", TypeDescription.class, "isImplicitTeaImport", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("implicitTeaImport");
            pd.setShortDescription("True if the class is \n implicitly imported by Tea.\n <p>\n Returns true if the specified class represents a primitive type or\n a class or interface defined in one of the IMPLICIT_TEA_IMPORTS \n packages.  This method also works for array types.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
          
        pd = null;
        try {         
            pd = new PropertyDescriptor("likelyContextClass", TypeDescription.class, "isLikelyContextClass", null);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        if (pd != null) {    
            pd.setDisplayName("likelyContextClass");
            pd.setShortDescription("True if it is likely that the class serves as \n a Tea runtime context class.");  
                  
            propertyDescriptors[propertyIndex] = pd;
            propertyIndex++;        
        }
        
        if (propertyDescriptors.length == 0) {
            propertyDescriptors = null;    
        }
        
        return propertyDescriptors;
    }

}